/* Database.c generated by valac 0.56.17, the Vala compiler
 * generated from Database.vala, do not modify */

/*
 * Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_DATABASE_0_PROPERTY,
	SERVICES_DATABASE_NUM_PROPERTIES
};
static GParamSpec* services_database_properties[SERVICES_DATABASE_NUM_PROPERTIES];
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	SERVICES_DATABASE_OPENED_SIGNAL,
	SERVICES_DATABASE_RESET_SIGNAL,
	SERVICES_DATABASE_NUM_SIGNALS
};
static guint services_database_signals[SERVICES_DATABASE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ServicesDatabasePrivate {
	sqlite3* db;
	gchar* db_path;
	gchar* errormsg;
	gchar* sql;
	JsonParser* parser;
};

static gint ServicesDatabase_private_offset;
static gpointer services_database_parent_class = NULL;
static ServicesDatabase* services_database__instance;
static ServicesDatabase* services_database__instance = NULL;

static void services_database_create_tables (ServicesDatabase* self);
static void services_database_create_triggers (ServicesDatabase* self);
static ObjectsSource* _services_database_fill_source (ServicesDatabase* self,
                                               sqlite3_stmt* stmt);
static gboolean services_database_get_parameter_bool (ServicesDatabase* self,
                                               sqlite3_stmt* stmt,
                                               gint col);
static void services_database_set_parameter_str (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          const gchar* val);
static void services_database_set_parameter_bool (ServicesDatabase* self,
                                           sqlite3_stmt* stmt,
                                           const gchar* par,
                                           gboolean val);
static void services_database_set_parameter_int (ServicesDatabase* self,
                                          sqlite3_stmt* stmt,
                                          const gchar* par,
                                          gint val);
static void services_database_set_parameter_int64 (ServicesDatabase* self,
                                            sqlite3_stmt* stmt,
                                            const gchar* par,
                                            gint64 val);
static void services_database_finalize (GObject * obj);
static GType services_database_get_type_once (void);

static inline gpointer
services_database_get_instance_private (ServicesDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesDatabase_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../core/Services/Database.vala"
	return self ? g_object_ref (self) : NULL;
#line 119 "Database.c"
}

ServicesDatabase*
services_database_get_default (void)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp2_;
	ServicesDatabase* _tmp3_;
	ServicesDatabase* result;
#line 33 "../core/Services/Database.vala"
	_tmp0_ = services_database__instance;
#line 33 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 133 "Database.c"
		ServicesDatabase* _tmp1_;
#line 34 "../core/Services/Database.vala"
		_tmp1_ = services_database_new ();
#line 34 "../core/Services/Database.vala"
		_g_object_unref0 (services_database__instance);
#line 34 "../core/Services/Database.vala"
		services_database__instance = _tmp1_;
#line 141 "Database.c"
	}
#line 37 "../core/Services/Database.vala"
	_tmp2_ = services_database__instance;
#line 37 "../core/Services/Database.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 37 "../core/Services/Database.vala"
	result = _tmp3_;
#line 37 "../core/Services/Database.vala"
	return result;
#line 151 "Database.c"
}

void
services_database_init_database (ServicesDatabase* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	sqlite3* _tmp6_ = NULL;
#line 40 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 41 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 41 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 41 "../core/Services/Database.vala"
	self->priv->db_path = _tmp1_;
#line 42 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db_path;
#line 42 "../core/Services/Database.vala"
	_tmp3_ = g_strdup_printf ("DB: %s\n", _tmp2_);
#line 42 "../core/Services/Database.vala"
	_tmp4_ = _tmp3_;
#line 42 "../core/Services/Database.vala"
	g_print ("%s", _tmp4_);
#line 42 "../core/Services/Database.vala"
	_g_free0 (_tmp4_);
#line 43 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db_path;
#line 43 "../core/Services/Database.vala"
	sqlite3_open (_tmp5_, &_tmp6_);
#line 43 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 43 "../core/Services/Database.vala"
	self->priv->db = _tmp6_;
#line 45 "../core/Services/Database.vala"
	services_database_create_tables (self);
#line 46 "../core/Services/Database.vala"
	services_database_create_triggers (self);
#line 47 "../core/Services/Database.vala"
	services_database_patch_database (self);
#line 48 "../core/Services/Database.vala"
	g_signal_emit (self, services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL], 0);
#line 200 "Database.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 229 "Database.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 240 "Database.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 246 "Database.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 258 "Database.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 262 "Database.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 266 "Database.c"
}

static void
services_database_create_tables (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	gchar* _tmp12_;
	sqlite3* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gint _tmp16_;
	gchar* _tmp18_;
	sqlite3* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gint _tmp22_;
	gchar* _tmp24_;
	sqlite3* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	gint _tmp28_;
	gchar* _tmp30_;
	sqlite3* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gint _tmp34_;
	gchar* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_ = NULL;
	gint _tmp40_;
	gchar* _tmp42_;
	sqlite3* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_ = NULL;
	gint _tmp46_;
	gchar* _tmp48_;
	sqlite3* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_ = NULL;
	gint _tmp52_;
	gchar* _tmp54_;
	sqlite3* _tmp55_;
	const gchar* _tmp56_;
	gchar* _tmp57_ = NULL;
	gint _tmp58_;
	gchar* _tmp60_;
	sqlite3* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_ = NULL;
	gint _tmp64_;
#line 51 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 52 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Labels (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                color           TEXT,\n" \
"                item_order      INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_favorite     INTEGER,\n" \
"                backend_type    TEXT,\n" \
"                source_id       TEXT,\n" \
"                CONSTRAINT unique_label UNIQUE (name)\n" \
"            );\n" \
"        ");
#line 52 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 52 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 66 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 66 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 66 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 66 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 66 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 66 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 347 "Database.c"
		const gchar* _tmp5_;
#line 67 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 67 "../core/Services/Database.vala"
		g_warning ("Database.vala:67: %s", _tmp5_);
#line 353 "Database.c"
	}
#line 70 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Projects (\n" \
"                id                      TEXT PRIMARY KEY,\n" \
"                name                    TEXT NOT NULL,\n" \
"                color                   TEXT,\n" \
"                backend_type            TEXT,\n" \
"                inbox_project           INTEGER,\n" \
"                team_inbox              INTEGER,\n" \
"                child_order             INTEGER,\n" \
"                is_deleted              INTEGER,\n" \
"                is_archived             INTEGER,\n" \
"                is_favorite             INTEGER,\n" \
"                shared                  INTEGER,\n" \
"                view_style              TEXT,\n" \
"                sort_order              INTEGER,\n" \
"                parent_id               TEXT,\n" \
"                collapsed               INTEGER,\n" \
"                icon_style              TEXT,\n" \
"                emoji                   TEXT,\n" \
"                show_completed          INTEGER,\n" \
"                description             TEXT,\n" \
"                due_date                TEXT,\n" \
"                inbox_section_hidded    INTEGER,\n" \
"                sync_id                 TEXT,\n" \
"                source_id               TEXT\n" \
"            );\n" \
"        ");
#line 70 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 70 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 98 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 98 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 98 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 98 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 98 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 98 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 373 "Database.c"
		const gchar* _tmp11_;
#line 99 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 99 "../core/Services/Database.vala"
		g_warning ("Database.vala:99: %s", _tmp11_);
#line 379 "Database.c"
	}
#line 102 "../core/Services/Database.vala"
	_tmp12_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Sections (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                name            TEXT,\n" \
"                archived_at     TEXT,\n" \
"                added_at        TEXT,\n" \
"                project_id      TEXT,\n" \
"                section_order   INTEGER,\n" \
"                collapsed       INTEGER,\n" \
"                is_deleted      INTEGER,\n" \
"                is_archived     INTEGER,\n" \
"                color           TEXT,\n" \
"                description     TEXT,\n" \
"                hidded          INTEGER,\n" \
"                FOREIGN KEY (project_id) REFERENCES Projects (id) ON D" \
"ELETE CASCADE\n" \
"            );\n" \
"        ");
#line 102 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 102 "../core/Services/Database.vala"
	self->priv->sql = _tmp12_;
#line 120 "../core/Services/Database.vala"
	_tmp13_ = self->priv->db;
#line 120 "../core/Services/Database.vala"
	_tmp14_ = self->priv->sql;
#line 120 "../core/Services/Database.vala"
	_tmp16_ = _sqlite3_exec (_tmp13_, _tmp14_, NULL, NULL, &_tmp15_);
#line 120 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 120 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp15_;
#line 120 "../core/Services/Database.vala"
	if (_tmp16_ != SQLITE_OK) {
#line 399 "Database.c"
		const gchar* _tmp17_;
#line 121 "../core/Services/Database.vala"
		_tmp17_ = self->priv->errormsg;
#line 121 "../core/Services/Database.vala"
		g_warning ("Database.vala:121: %s", _tmp17_);
#line 405 "Database.c"
	}
#line 124 "../core/Services/Database.vala"
	_tmp18_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Items (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                content             TEXT NOT NULL,\n" \
"                description         TEXT,\n" \
"                due                 TEXT,\n" \
"                added_at            TEXT,\n" \
"                completed_at        TEXT,\n" \
"                updated_at          TEXT,\n" \
"                section_id          TEXT,\n" \
"                project_id          TEXT,\n" \
"                parent_id           TEXT,\n" \
"                priority            INTEGER,\n" \
"                child_order         INTEGER,\n" \
"                checked             INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                day_order           INTEGER,\n" \
"                collapsed           INTEGER,\n" \
"                pinned              INTEGER,\n" \
"                labels              TEXT,\n" \
"                extra_data          TEXT,\n" \
"                item_type           TEXT\n" \
"            );\n" \
"        ");
#line 124 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 124 "../core/Services/Database.vala"
	self->priv->sql = _tmp18_;
#line 149 "../core/Services/Database.vala"
	_tmp19_ = self->priv->db;
#line 149 "../core/Services/Database.vala"
	_tmp20_ = self->priv->sql;
#line 149 "../core/Services/Database.vala"
	_tmp22_ = _sqlite3_exec (_tmp19_, _tmp20_, NULL, NULL, &_tmp21_);
#line 149 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 149 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp21_;
#line 149 "../core/Services/Database.vala"
	if (_tmp22_ != SQLITE_OK) {
#line 425 "Database.c"
		const gchar* _tmp23_;
#line 150 "../core/Services/Database.vala"
		_tmp23_ = self->priv->errormsg;
#line 150 "../core/Services/Database.vala"
		g_warning ("Database.vala:150: %s", _tmp23_);
#line 431 "Database.c"
	}
#line 153 "../core/Services/Database.vala"
	_tmp24_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Reminders (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                notify_uid          INTEGER,\n" \
"                item_id             TEXT,\n" \
"                service             TEXT,\n" \
"                type                TEXT,\n" \
"                due                 TEXT,\n" \
"                mm_offset           INTEGER,\n" \
"                is_deleted          INTEGER,\n" \
"                FOREIGN KEY (item_id) REFERENCES Items (id) ON DELETE " \
"CASCADE\n" \
"            );\n" \
"        ");
#line 153 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 153 "../core/Services/Database.vala"
	self->priv->sql = _tmp24_;
#line 167 "../core/Services/Database.vala"
	_tmp25_ = self->priv->db;
#line 167 "../core/Services/Database.vala"
	_tmp26_ = self->priv->sql;
#line 167 "../core/Services/Database.vala"
	_tmp28_ = _sqlite3_exec (_tmp25_, _tmp26_, NULL, NULL, &_tmp27_);
#line 167 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 167 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp27_;
#line 167 "../core/Services/Database.vala"
	if (_tmp28_ != SQLITE_OK) {
#line 451 "Database.c"
		const gchar* _tmp29_;
#line 168 "../core/Services/Database.vala"
		_tmp29_ = self->priv->errormsg;
#line 168 "../core/Services/Database.vala"
		g_warning ("Database.vala:168: %s", _tmp29_);
#line 457 "Database.c"
	}
#line 171 "../core/Services/Database.vala"
	_tmp30_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Queue (\n" \
"                uuid       TEXT PRIMARY KEY,\n" \
"                object_id  TEXT,\n" \
"                query      TEXT,\n" \
"                temp_id    TEXT,\n" \
"                args       TEXT,\n" \
"                date_added TEXT\n" \
"            );\n" \
"        ");
#line 171 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 171 "../core/Services/Database.vala"
	self->priv->sql = _tmp30_;
#line 182 "../core/Services/Database.vala"
	_tmp31_ = self->priv->db;
#line 182 "../core/Services/Database.vala"
	_tmp32_ = self->priv->sql;
#line 182 "../core/Services/Database.vala"
	_tmp34_ = _sqlite3_exec (_tmp31_, _tmp32_, NULL, NULL, &_tmp33_);
#line 182 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 182 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp33_;
#line 182 "../core/Services/Database.vala"
	if (_tmp34_ != SQLITE_OK) {
#line 477 "Database.c"
		const gchar* _tmp35_;
#line 183 "../core/Services/Database.vala"
		_tmp35_ = self->priv->errormsg;
#line 183 "../core/Services/Database.vala"
		g_warning ("Database.vala:183: %s", _tmp35_);
#line 483 "Database.c"
	}
#line 186 "../core/Services/Database.vala"
	_tmp36_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS CurTempIds (\n" \
"                id          TEXT PRIMARY KEY,\n" \
"                temp_id     TEXT,\n" \
"                object      TEXT\n" \
"            );\n" \
"        ");
#line 186 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 186 "../core/Services/Database.vala"
	self->priv->sql = _tmp36_;
#line 194 "../core/Services/Database.vala"
	_tmp37_ = self->priv->db;
#line 194 "../core/Services/Database.vala"
	_tmp38_ = self->priv->sql;
#line 194 "../core/Services/Database.vala"
	_tmp40_ = _sqlite3_exec (_tmp37_, _tmp38_, NULL, NULL, &_tmp39_);
#line 194 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 194 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp39_;
#line 194 "../core/Services/Database.vala"
	if (_tmp40_ != SQLITE_OK) {
#line 503 "Database.c"
		const gchar* _tmp41_;
#line 195 "../core/Services/Database.vala"
		_tmp41_ = self->priv->errormsg;
#line 195 "../core/Services/Database.vala"
		g_warning ("Database.vala:195: %s", _tmp41_);
#line 509 "Database.c"
	}
#line 198 "../core/Services/Database.vala"
	_tmp42_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Attachments (\n" \
"                id              TEXT PRIMARY KEY,\n" \
"                item_id         TEXT,\n" \
"                file_type       TEXT,\n" \
"                file_name       TEXT,\n" \
"                file_size       TEXT,\n" \
"                file_path       TEXT,\n" \
"                FOREIGN KEY (item_id) REFERENCES Items (id) ON DELETE " \
"CASCADE\n" \
"            );\n" \
"        ");
#line 198 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 198 "../core/Services/Database.vala"
	self->priv->sql = _tmp42_;
#line 210 "../core/Services/Database.vala"
	_tmp43_ = self->priv->db;
#line 210 "../core/Services/Database.vala"
	_tmp44_ = self->priv->sql;
#line 210 "../core/Services/Database.vala"
	_tmp46_ = _sqlite3_exec (_tmp43_, _tmp44_, NULL, NULL, &_tmp45_);
#line 210 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 210 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp45_;
#line 210 "../core/Services/Database.vala"
	if (_tmp46_ != SQLITE_OK) {
#line 529 "Database.c"
		const gchar* _tmp47_;
#line 211 "../core/Services/Database.vala"
		_tmp47_ = self->priv->errormsg;
#line 211 "../core/Services/Database.vala"
		g_warning ("Database.vala:211: %s", _tmp47_);
#line 535 "Database.c"
	}
#line 214 "../core/Services/Database.vala"
	_tmp48_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS OEvents (\n" \
"                id                  INTEGER PRIMARY KEY AUTOINCREMENT," \
"\n" \
"                event_type          TEXT,\n" \
"                event_date          DATETIME DEFAULT (datetime('now','" \
"localtime')),\n" \
"                object_id           TEXT,\n" \
"                object_type         TEXT,\n" \
"                object_key          TEXT,\n" \
"                object_old_value    TEXT,\n" \
"                object_new_value    TEXT,\n" \
"                parent_item_id      TEXT,\n" \
"                parent_project_id   TEXT\n" \
"            );\n" \
"        ");
#line 214 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 214 "../core/Services/Database.vala"
	self->priv->sql = _tmp48_;
#line 229 "../core/Services/Database.vala"
	_tmp49_ = self->priv->db;
#line 229 "../core/Services/Database.vala"
	_tmp50_ = self->priv->sql;
#line 229 "../core/Services/Database.vala"
	_tmp52_ = _sqlite3_exec (_tmp49_, _tmp50_, NULL, NULL, &_tmp51_);
#line 229 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 229 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp51_;
#line 229 "../core/Services/Database.vala"
	if (_tmp52_ != SQLITE_OK) {
#line 555 "Database.c"
		const gchar* _tmp53_;
#line 230 "../core/Services/Database.vala"
		_tmp53_ = self->priv->errormsg;
#line 230 "../core/Services/Database.vala"
		g_warning ("Database.vala:230: %s", _tmp53_);
#line 561 "Database.c"
	}
#line 233 "../core/Services/Database.vala"
	_tmp54_ = g_strdup ("\n" \
"            CREATE TABLE IF NOT EXISTS Sources (\n" \
"                id                  TEXT PRIMARY KEY,\n" \
"                source_type         TEXT NOT NULL,\n" \
"                display_name        TEXT,\n" \
"                added_at            TEXT,\n" \
"                updated_at          TEXT,\n" \
"                is_visible          INTEGER,\n" \
"                child_order         INTEGER,\n" \
"                sync_server         INTEGER,\n" \
"                last_sync           TEXT,\n" \
"                data                TEXT\n" \
"            );\n" \
"        ");
#line 233 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 233 "../core/Services/Database.vala"
	self->priv->sql = _tmp54_;
#line 248 "../core/Services/Database.vala"
	_tmp55_ = self->priv->db;
#line 248 "../core/Services/Database.vala"
	_tmp56_ = self->priv->sql;
#line 248 "../core/Services/Database.vala"
	_tmp58_ = _sqlite3_exec (_tmp55_, _tmp56_, NULL, NULL, &_tmp57_);
#line 248 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 248 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp57_;
#line 248 "../core/Services/Database.vala"
	if (_tmp58_ != SQLITE_OK) {
#line 581 "Database.c"
		const gchar* _tmp59_;
#line 249 "../core/Services/Database.vala"
		_tmp59_ = self->priv->errormsg;
#line 249 "../core/Services/Database.vala"
		g_warning ("Database.vala:249: %s", _tmp59_);
#line 587 "Database.c"
	}
#line 252 "../core/Services/Database.vala"
	_tmp60_ = g_strdup ("PRAGMA foreign_keys = ON;");
#line 252 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 252 "../core/Services/Database.vala"
	self->priv->sql = _tmp60_;
#line 254 "../core/Services/Database.vala"
	_tmp61_ = self->priv->db;
#line 254 "../core/Services/Database.vala"
	_tmp62_ = self->priv->sql;
#line 254 "../core/Services/Database.vala"
	_tmp64_ = _sqlite3_exec (_tmp61_, _tmp62_, NULL, NULL, &_tmp63_);
#line 254 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 254 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp63_;
#line 254 "../core/Services/Database.vala"
	if (_tmp64_ != SQLITE_OK) {
#line 607 "Database.c"
		const gchar* _tmp65_;
#line 255 "../core/Services/Database.vala"
		_tmp65_ = self->priv->errormsg;
#line 255 "../core/Services/Database.vala"
		g_warning ("Database.vala:255: %s", _tmp65_);
#line 613 "Database.c"
	}
}

static void
services_database_create_triggers (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	gchar* _tmp12_;
	sqlite3* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gint _tmp16_;
	gchar* _tmp18_;
	sqlite3* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gint _tmp22_;
	gchar* _tmp24_;
	sqlite3* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	gint _tmp28_;
	gchar* _tmp30_;
	sqlite3* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gint _tmp34_;
	gchar* _tmp36_;
	sqlite3* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_ = NULL;
	gint _tmp40_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	sqlite3* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_ = NULL;
	gint _tmp47_;
	gchar* _tmp49_;
	sqlite3* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_ = NULL;
	gint _tmp53_;
#line 259 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 260 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_insert_item\n" \
"            AFTER INSERT ON Items\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"insert\", NEW.id, \"item\", \"content\", NEW" \
".content,\n" \
"                    NEW.content, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 260 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 260 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 271 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 271 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 271 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 271 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 271 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 271 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 686 "Database.c"
		const gchar* _tmp5_;
#line 272 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 272 "../core/Services/Database.vala"
		g_warning ("Database.vala:272: %s", _tmp5_);
#line 692 "Database.c"
	}
#line 275 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_content_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.content != OLD.content\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"content\", OLD" \
".content,\n" \
"                    NEW.content, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 275 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 275 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 288 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 288 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 288 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 288 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 288 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 288 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 712 "Database.c"
		const gchar* _tmp11_;
#line 289 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 289 "../core/Services/Database.vala"
		g_warning ("Database.vala:289: %s", _tmp11_);
#line 718 "Database.c"
	}
#line 292 "../core/Services/Database.vala"
	_tmp12_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_description_item" \
"\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.description != OLD.description\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"description\"," \
" OLD.description,\n" \
"                    NEW.description, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 292 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 292 "../core/Services/Database.vala"
	self->priv->sql = _tmp12_;
#line 305 "../core/Services/Database.vala"
	_tmp13_ = self->priv->db;
#line 305 "../core/Services/Database.vala"
	_tmp14_ = self->priv->sql;
#line 305 "../core/Services/Database.vala"
	_tmp16_ = _sqlite3_exec (_tmp13_, _tmp14_, NULL, NULL, &_tmp15_);
#line 305 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 305 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp15_;
#line 305 "../core/Services/Database.vala"
	if (_tmp16_ != SQLITE_OK) {
#line 738 "Database.c"
		const gchar* _tmp17_;
#line 306 "../core/Services/Database.vala"
		_tmp17_ = self->priv->errormsg;
#line 306 "../core/Services/Database.vala"
		g_warning ("Database.vala:306: %s", _tmp17_);
#line 744 "Database.c"
	}
#line 309 "../core/Services/Database.vala"
	_tmp18_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_due_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.due != OLD.due\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"due\", OLD.due" \
",\n" \
"                    NEW.due, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 309 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 309 "../core/Services/Database.vala"
	self->priv->sql = _tmp18_;
#line 322 "../core/Services/Database.vala"
	_tmp19_ = self->priv->db;
#line 322 "../core/Services/Database.vala"
	_tmp20_ = self->priv->sql;
#line 322 "../core/Services/Database.vala"
	_tmp22_ = _sqlite3_exec (_tmp19_, _tmp20_, NULL, NULL, &_tmp21_);
#line 322 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 322 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp21_;
#line 322 "../core/Services/Database.vala"
	if (_tmp22_ != SQLITE_OK) {
#line 764 "Database.c"
		const gchar* _tmp23_;
#line 323 "../core/Services/Database.vala"
		_tmp23_ = self->priv->errormsg;
#line 323 "../core/Services/Database.vala"
		g_warning ("Database.vala:323: %s", _tmp23_);
#line 770 "Database.c"
	}
#line 326 "../core/Services/Database.vala"
	_tmp24_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_priority_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.priority != OLD.priority\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"priority\", OL" \
"D.priority,\n" \
"                    NEW.priority, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 326 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 326 "../core/Services/Database.vala"
	self->priv->sql = _tmp24_;
#line 339 "../core/Services/Database.vala"
	_tmp25_ = self->priv->db;
#line 339 "../core/Services/Database.vala"
	_tmp26_ = self->priv->sql;
#line 339 "../core/Services/Database.vala"
	_tmp28_ = _sqlite3_exec (_tmp25_, _tmp26_, NULL, NULL, &_tmp27_);
#line 339 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 339 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp27_;
#line 339 "../core/Services/Database.vala"
	if (_tmp28_ != SQLITE_OK) {
#line 790 "Database.c"
		const gchar* _tmp29_;
#line 340 "../core/Services/Database.vala"
		_tmp29_ = self->priv->errormsg;
#line 340 "../core/Services/Database.vala"
		g_warning ("Database.vala:340: %s", _tmp29_);
#line 796 "Database.c"
	}
#line 343 "../core/Services/Database.vala"
	_tmp30_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_labels_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.labels != OLD.labels\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"labels\", OLD." \
"labels,\n" \
"                    NEW.labels, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 343 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 343 "../core/Services/Database.vala"
	self->priv->sql = _tmp30_;
#line 356 "../core/Services/Database.vala"
	_tmp31_ = self->priv->db;
#line 356 "../core/Services/Database.vala"
	_tmp32_ = self->priv->sql;
#line 356 "../core/Services/Database.vala"
	_tmp34_ = _sqlite3_exec (_tmp31_, _tmp32_, NULL, NULL, &_tmp33_);
#line 356 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 356 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp33_;
#line 356 "../core/Services/Database.vala"
	if (_tmp34_ != SQLITE_OK) {
#line 816 "Database.c"
		const gchar* _tmp35_;
#line 357 "../core/Services/Database.vala"
		_tmp35_ = self->priv->errormsg;
#line 357 "../core/Services/Database.vala"
		g_warning ("Database.vala:357: %s", _tmp35_);
#line 822 "Database.c"
	}
#line 360 "../core/Services/Database.vala"
	_tmp36_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_pinned_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.pinned != OLD.pinned\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"pinned\", OLD." \
"pinned,\n" \
"                    NEW.pinned, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 360 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 360 "../core/Services/Database.vala"
	self->priv->sql = _tmp36_;
#line 373 "../core/Services/Database.vala"
	_tmp37_ = self->priv->db;
#line 373 "../core/Services/Database.vala"
	_tmp38_ = self->priv->sql;
#line 373 "../core/Services/Database.vala"
	_tmp40_ = _sqlite3_exec (_tmp37_, _tmp38_, NULL, NULL, &_tmp39_);
#line 373 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 373 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp39_;
#line 373 "../core/Services/Database.vala"
	if (_tmp40_ != SQLITE_OK) {
#line 842 "Database.c"
		const gchar* _tmp41_;
#line 374 "../core/Services/Database.vala"
		_tmp41_ = self->priv->errormsg;
#line 374 "../core/Services/Database.vala"
		g_warning ("Database.vala:374: %s", _tmp41_);
#line 848 "Database.c"
	}
#line 377 "../core/Services/Database.vala"
	_tmp42_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_checked_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.checked != OLD.checked\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"checked\", OLD" \
".checked,\n" \
"                    NEW.checked, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 377 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 377 "../core/Services/Database.vala"
	self->priv->sql = _tmp42_;
#line 390 "../core/Services/Database.vala"
	_tmp43_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_section_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.section_id != OLD.section_id\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"section\", OLD" \
".section_id,\n" \
"                    NEW.section_id, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 390 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 390 "../core/Services/Database.vala"
	self->priv->sql = _tmp43_;
#line 403 "../core/Services/Database.vala"
	_tmp44_ = self->priv->db;
#line 403 "../core/Services/Database.vala"
	_tmp45_ = self->priv->sql;
#line 403 "../core/Services/Database.vala"
	_tmp47_ = _sqlite3_exec (_tmp44_, _tmp45_, NULL, NULL, &_tmp46_);
#line 403 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 403 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp46_;
#line 403 "../core/Services/Database.vala"
	if (_tmp47_ != SQLITE_OK) {
#line 874 "Database.c"
		const gchar* _tmp48_;
#line 404 "../core/Services/Database.vala"
		_tmp48_ = self->priv->errormsg;
#line 404 "../core/Services/Database.vala"
		g_warning ("Database.vala:404: %s", _tmp48_);
#line 880 "Database.c"
	}
#line 407 "../core/Services/Database.vala"
	_tmp49_ = g_strdup ("\n" \
"            CREATE TRIGGER IF NOT EXISTS after_update_project_item\n" \
"            AFTER UPDATE ON Items\n" \
"            FOR EACH ROW\n" \
"            WHEN NEW.project_id != OLD.project_id\n" \
"            BEGIN\n" \
"                INSERT OR IGNORE INTO OEvents (event_type, object_id,\n" \
"                    object_type, object_key, object_old_value, object_" \
"new_value, parent_project_id)\n" \
"                VALUES (\"update\", NEW.id, \"item\", \"project\", OLD" \
".project_id,\n" \
"                    NEW.project_id, NEW.project_id);\n" \
"            END;\n" \
"        ");
#line 407 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 407 "../core/Services/Database.vala"
	self->priv->sql = _tmp49_;
#line 420 "../core/Services/Database.vala"
	_tmp50_ = self->priv->db;
#line 420 "../core/Services/Database.vala"
	_tmp51_ = self->priv->sql;
#line 420 "../core/Services/Database.vala"
	_tmp53_ = _sqlite3_exec (_tmp50_, _tmp51_, NULL, NULL, &_tmp52_);
#line 420 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 420 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp52_;
#line 420 "../core/Services/Database.vala"
	if (_tmp53_ != SQLITE_OK) {
#line 900 "Database.c"
		const gchar* _tmp54_;
#line 421 "../core/Services/Database.vala"
		_tmp54_ = self->priv->errormsg;
#line 421 "../core/Services/Database.vala"
		g_warning ("Database.vala:421: %s", _tmp54_);
#line 906 "Database.c"
	}
}

void
services_database_patch_database (ServicesDatabase* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 425 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 431 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Items", "pinned", 0);
#line 438 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "show_completed", 0);
#line 446 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "description", "");
#line 455 "../core/Services/Database.vala"
	services_database_add_item_label_column (self);
#line 456 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "color", "blue");
#line 457 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Sections", "description", "");
#line 464 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Items", "extra_data", "");
#line 465 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Sections", "hidded", 0);
#line 466 "../core/Services/Database.vala"
	services_database_add_int_column (self, "Projects", "inbox_section_hidded", 0);
#line 473 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Projects", "sync_id", "");
#line 480 "../core/Services/Database.vala"
	_tmp0_ = item_type_to_string (ITEM_TYPE_TASK);
#line 480 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 480 "../core/Services/Database.vala"
	services_database_add_text_column (self, "Items", "item_type", _tmp1_);
#line 480 "../core/Services/Database.vala"
	_g_free0 (_tmp1_);
#line 487 "../core/Services/Database.vala"
	services_database_add_project_labels_source_id (self);
#line 947 "Database.c"
}

void
services_database_clear_database (ServicesDatabase* self)
{
	gchar* db_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* db_file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 490 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 491 "../core/Services/Database.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 491 "../core/Services/Database.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/io.github.alainm23.planify/database.db", NULL);
#line 491 "../core/Services/Database.vala"
	db_path = _tmp1_;
#line 492 "../core/Services/Database.vala"
	_tmp2_ = db_path;
#line 492 "../core/Services/Database.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 492 "../core/Services/Database.vala"
	db_file = _tmp3_;
#line 494 "../core/Services/Database.vala"
	_tmp4_ = db_file;
#line 494 "../core/Services/Database.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 979 "Database.c"
		{
			GFile* _tmp5_;
#line 496 "../core/Services/Database.vala"
			_tmp5_ = db_file;
#line 496 "../core/Services/Database.vala"
			g_file_delete (_tmp5_, NULL, &_inner_error0_);
#line 496 "../core/Services/Database.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 988 "Database.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 495 "../core/Services/Database.vala"
			err = _inner_error0_;
#line 495 "../core/Services/Database.vala"
			_inner_error0_ = NULL;
#line 498 "../core/Services/Database.vala"
			_tmp6_ = err;
#line 498 "../core/Services/Database.vala"
			_tmp7_ = _tmp6_->message;
#line 498 "../core/Services/Database.vala"
			g_warning ("Database.vala:498: %s", _tmp7_);
#line 495 "../core/Services/Database.vala"
			_g_error_free0 (err);
#line 1010 "Database.c"
		}
		__finally0:
#line 495 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 495 "../core/Services/Database.vala"
			_g_object_unref0 (db_file);
#line 495 "../core/Services/Database.vala"
			_g_free0 (db_path);
#line 495 "../core/Services/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 495 "../core/Services/Database.vala"
			g_clear_error (&_inner_error0_);
#line 495 "../core/Services/Database.vala"
			return;
#line 1025 "Database.c"
		}
	}
#line 490 "../core/Services/Database.vala"
	_g_object_unref0 (db_file);
#line 490 "../core/Services/Database.vala"
	_g_free0 (db_path);
#line 1032 "Database.c"
}

GeeArrayList*
services_database_get_sources_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 507 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 508 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 508 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 512 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Sources ORDER BY child_order;\n        ");
#line 512 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 512 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 516 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 516 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 516 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 516 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 516 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 516 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 516 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 516 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 518 "../core/Services/Database.vala"
	while (TRUE) {
#line 1079 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsSource* _tmp11_;
		ObjectsSource* _tmp12_;
#line 518 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 518 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 518 "../core/Services/Database.vala"
			break;
#line 1091 "Database.c"
		}
#line 519 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 519 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 519 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_source (self, _tmp10_);
#line 519 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 519 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 519 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 1105 "Database.c"
	}
#line 522 "../core/Services/Database.vala"
	result = return_value;
#line 522 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 522 "../core/Services/Database.vala"
	return result;
#line 1113 "Database.c"
}

static ObjectsSource*
_services_database_fill_source (ServicesDatabase* self,
                                sqlite3_stmt* stmt)
{
	ObjectsSource* return_value = NULL;
	ObjectsSource* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	ObjectsSource* _tmp3_;
	const gchar* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	ObjectsSource* _tmp7_;
	const gchar* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	ObjectsSource* _tmp11_;
	ObjectsSource* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSource* _tmp14_;
	const gchar* _tmp15_;
	ObjectsSource* _tmp16_;
	SourceType _tmp17_;
	SourceType _tmp18_;
	ObjectsSource* result;
#line 525 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 525 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 526 "../core/Services/Database.vala"
	_tmp0_ = objects_source_new ();
#line 526 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 527 "../core/Services/Database.vala"
	_tmp1_ = return_value;
#line 527 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 527 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp1_, _tmp2_);
#line 528 "../core/Services/Database.vala"
	_tmp3_ = return_value;
#line 528 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 528 "../core/Services/Database.vala"
	objects_source_set_source_type (_tmp3_, source_type_parse (_tmp4_));
#line 529 "../core/Services/Database.vala"
	_tmp5_ = return_value;
#line 529 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 529 "../core/Services/Database.vala"
	objects_source_set_display_name (_tmp5_, _tmp6_);
#line 530 "../core/Services/Database.vala"
	_tmp7_ = return_value;
#line 530 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 530 "../core/Services/Database.vala"
	objects_source_set_added_at (_tmp7_, _tmp8_);
#line 531 "../core/Services/Database.vala"
	_tmp9_ = return_value;
#line 531 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 531 "../core/Services/Database.vala"
	objects_source_set_updated_at (_tmp9_, _tmp10_);
#line 532 "../core/Services/Database.vala"
	_tmp11_ = return_value;
#line 532 "../core/Services/Database.vala"
	objects_source_set_is_visible (_tmp11_, services_database_get_parameter_bool (self, stmt, 5));
#line 533 "../core/Services/Database.vala"
	_tmp12_ = return_value;
#line 533 "../core/Services/Database.vala"
	objects_source_set_child_order (_tmp12_, sqlite3_column_int (stmt, 6));
#line 534 "../core/Services/Database.vala"
	_tmp13_ = return_value;
#line 534 "../core/Services/Database.vala"
	objects_source_set_sync_server (_tmp13_, services_database_get_parameter_bool (self, stmt, 7));
#line 535 "../core/Services/Database.vala"
	_tmp14_ = return_value;
#line 535 "../core/Services/Database.vala"
	_tmp15_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 535 "../core/Services/Database.vala"
	objects_source_set_last_sync (_tmp14_, _tmp15_);
#line 537 "../core/Services/Database.vala"
	_tmp16_ = return_value;
#line 537 "../core/Services/Database.vala"
	_tmp17_ = objects_source_get_source_type (_tmp16_);
#line 537 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 537 "../core/Services/Database.vala"
	if (_tmp18_ == SOURCE_TYPE_TODOIST) {
#line 1205 "Database.c"
		ObjectsSource* _tmp19_;
		const gchar* _tmp20_;
		ObjectsSourceTodoistData* _tmp21_;
		ObjectsSourceTodoistData* _tmp22_;
#line 538 "../core/Services/Database.vala"
		_tmp19_ = return_value;
#line 538 "../core/Services/Database.vala"
		_tmp20_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 538 "../core/Services/Database.vala"
		_tmp21_ = objects_source_todoist_data_new_from_json (_tmp20_);
#line 538 "../core/Services/Database.vala"
		_tmp22_ = _tmp21_;
#line 538 "../core/Services/Database.vala"
		objects_source_set_data (_tmp19_, (ObjectsSourceData*) _tmp22_);
#line 538 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp22_);
#line 1222 "Database.c"
	} else {
		ObjectsSource* _tmp23_;
		SourceType _tmp24_;
		SourceType _tmp25_;
#line 539 "../core/Services/Database.vala"
		_tmp23_ = return_value;
#line 539 "../core/Services/Database.vala"
		_tmp24_ = objects_source_get_source_type (_tmp23_);
#line 539 "../core/Services/Database.vala"
		_tmp25_ = _tmp24_;
#line 539 "../core/Services/Database.vala"
		if (_tmp25_ == SOURCE_TYPE_CALDAV) {
#line 1235 "Database.c"
			ObjectsSource* _tmp26_;
			const gchar* _tmp27_;
			ObjectsSourceCalDAVData* _tmp28_;
			ObjectsSourceCalDAVData* _tmp29_;
#line 540 "../core/Services/Database.vala"
			_tmp26_ = return_value;
#line 540 "../core/Services/Database.vala"
			_tmp27_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 540 "../core/Services/Database.vala"
			_tmp28_ = objects_source_cal_dav_data_new_from_json (_tmp27_);
#line 540 "../core/Services/Database.vala"
			_tmp29_ = _tmp28_;
#line 540 "../core/Services/Database.vala"
			objects_source_set_data (_tmp26_, (ObjectsSourceData*) _tmp29_);
#line 540 "../core/Services/Database.vala"
			_g_object_unref0 (_tmp29_);
#line 1252 "Database.c"
		}
	}
#line 543 "../core/Services/Database.vala"
	result = return_value;
#line 543 "../core/Services/Database.vala"
	return result;
#line 1259 "Database.c"
}

gboolean
services_database_insert_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	SourceType _tmp11_;
	SourceType _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	ObjectsSourceData* _tmp37_;
	ObjectsSourceData* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	sqlite3_stmt* _tmp41_;
	sqlite3_stmt* _tmp45_;
	gboolean result;
#line 546 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 546 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 549 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Sources (id, source_type, display_na" \
"me, added_at,\n" \
"                updated_at, is_visible, child_order, sync_server, last" \
"_sync, data)\n" \
"            VALUES ($id, $source_type, $display_name, $added_at,\n" \
"                $updated_at, $is_visible, $child_order, $sync_server, " \
"$last_sync, $data);\n" \
"        ");
#line 549 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 549 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 556 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 556 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 556 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 556 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 556 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 556 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 556 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 556 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 557 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 557 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 557 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 557 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 558 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 558 "../core/Services/Database.vala"
	_tmp11_ = objects_source_get_source_type (source);
#line 558 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 558 "../core/Services/Database.vala"
	_tmp13_ = source_type_to_string (_tmp12_);
#line 558 "../core/Services/Database.vala"
	_tmp14_ = _tmp13_;
#line 558 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$source_type", _tmp14_);
#line 558 "../core/Services/Database.vala"
	_g_free0 (_tmp14_);
#line 559 "../core/Services/Database.vala"
	_tmp15_ = stmt;
#line 559 "../core/Services/Database.vala"
	_tmp16_ = objects_source_get_display_name (source);
#line 559 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 559 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp15_, "$display_name", _tmp17_);
#line 560 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 560 "../core/Services/Database.vala"
	_tmp19_ = objects_source_get_added_at (source);
#line 560 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 560 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp18_, "$added_at", _tmp20_);
#line 561 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 561 "../core/Services/Database.vala"
	_tmp22_ = objects_source_get_updated_at (source);
#line 561 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 561 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp21_, "$updated_at", _tmp23_);
#line 562 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 562 "../core/Services/Database.vala"
	_tmp25_ = objects_source_get_is_visible (source);
#line 562 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 562 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$is_visible", _tmp26_);
#line 563 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 563 "../core/Services/Database.vala"
	_tmp28_ = objects_source_get_child_order (source);
#line 563 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 563 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp27_, "$child_order", _tmp29_);
#line 564 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 564 "../core/Services/Database.vala"
	_tmp31_ = objects_source_get_sync_server (source);
#line 564 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 564 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$sync_server", _tmp32_);
#line 565 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 565 "../core/Services/Database.vala"
	_tmp34_ = objects_source_get_last_sync (source);
#line 565 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 565 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp33_, "$last_sync", _tmp35_);
#line 566 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 566 "../core/Services/Database.vala"
	_tmp37_ = objects_source_get_data (source);
#line 566 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 566 "../core/Services/Database.vala"
	_tmp39_ = objects_source_data_to_json (_tmp38_);
#line 566 "../core/Services/Database.vala"
	_tmp40_ = _tmp39_;
#line 566 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp36_, "$data", _tmp40_);
#line 566 "../core/Services/Database.vala"
	_g_free0 (_tmp40_);
#line 568 "../core/Services/Database.vala"
	_tmp41_ = stmt;
#line 568 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp41_) != SQLITE_DONE) {
#line 1433 "Database.c"
		sqlite3* _tmp42_;
		sqlite3* _tmp43_;
		const gchar* _tmp44_;
#line 569 "../core/Services/Database.vala"
		_tmp42_ = self->priv->db;
#line 569 "../core/Services/Database.vala"
		_tmp43_ = self->priv->db;
#line 569 "../core/Services/Database.vala"
		_tmp44_ = sqlite3_errmsg (_tmp43_);
#line 569 "../core/Services/Database.vala"
		g_warning ("Database.vala:569: Error: %d: %s", sqlite3_errcode (_tmp42_), _tmp44_);
#line 1445 "Database.c"
	}
#line 572 "../core/Services/Database.vala"
	_tmp45_ = stmt;
#line 572 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp45_) == SQLITE_DONE;
#line 572 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 572 "../core/Services/Database.vala"
	return result;
#line 1455 "Database.c"
}

gboolean
services_database_delete_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 575 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 578 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Sources WHERE id=$id;\n        ");
#line 578 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 578 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 582 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 582 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 582 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 582 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 582 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 582 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 582 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 582 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 583 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 583 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 583 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 583 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 585 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 585 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 1514 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 586 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 586 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 586 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 586 "../core/Services/Database.vala"
		g_warning ("Database.vala:586: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 1526 "Database.c"
	}
#line 589 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 589 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 589 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 589 "../core/Services/Database.vala"
	return result;
#line 1536 "Database.c"
}

gboolean
services_database_update_source (ServicesDatabase* self,
                                 ObjectsSource* source)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	SourceType _tmp8_;
	SourceType _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	sqlite3_stmt* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	ObjectsSourceData* _tmp31_;
	ObjectsSourceData* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	sqlite3_stmt* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	sqlite3_stmt* _tmp38_;
	sqlite3_stmt* _tmp42_;
	gboolean result;
#line 592 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 592 "../core/Services/Database.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 595 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sources SET\n" \
"                source_type=$source_type,\n" \
"                display_name=$display_name,\n" \
"                updated_at=$updated_at,\n" \
"                is_visible=$is_visible,\n" \
"                child_order=$child_order,\n" \
"                sync_server=$sync_server,\n" \
"                last_sync=$last_sync,\n" \
"                data=$data\n" \
"            WHERE id=$id;\n" \
"        ");
#line 595 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 595 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 608 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 608 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 608 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 608 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 608 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 608 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 608 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 608 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 609 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 609 "../core/Services/Database.vala"
	_tmp8_ = objects_source_get_source_type (source);
#line 609 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 609 "../core/Services/Database.vala"
	_tmp10_ = source_type_to_string (_tmp9_);
#line 609 "../core/Services/Database.vala"
	_tmp11_ = _tmp10_;
#line 609 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$source_type", _tmp11_);
#line 609 "../core/Services/Database.vala"
	_g_free0 (_tmp11_);
#line 610 "../core/Services/Database.vala"
	_tmp12_ = stmt;
#line 610 "../core/Services/Database.vala"
	_tmp13_ = objects_source_get_display_name (source);
#line 610 "../core/Services/Database.vala"
	_tmp14_ = _tmp13_;
#line 610 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp12_, "$display_name", _tmp14_);
#line 611 "../core/Services/Database.vala"
	_tmp15_ = stmt;
#line 611 "../core/Services/Database.vala"
	_tmp16_ = objects_source_get_updated_at (source);
#line 611 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 611 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp15_, "$updated_at", _tmp17_);
#line 612 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 612 "../core/Services/Database.vala"
	_tmp19_ = objects_source_get_is_visible (source);
#line 612 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 612 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp18_, "$is_visible", _tmp20_);
#line 613 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 613 "../core/Services/Database.vala"
	_tmp22_ = objects_source_get_child_order (source);
#line 613 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 613 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp21_, "$child_order", _tmp23_);
#line 614 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 614 "../core/Services/Database.vala"
	_tmp25_ = objects_source_get_sync_server (source);
#line 614 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 614 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$sync_server", _tmp26_);
#line 615 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 615 "../core/Services/Database.vala"
	_tmp28_ = objects_source_get_last_sync (source);
#line 615 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 615 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$last_sync", _tmp29_);
#line 616 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 616 "../core/Services/Database.vala"
	_tmp31_ = objects_source_get_data (source);
#line 616 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 616 "../core/Services/Database.vala"
	_tmp33_ = objects_source_data_to_json (_tmp32_);
#line 616 "../core/Services/Database.vala"
	_tmp34_ = _tmp33_;
#line 616 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$data", _tmp34_);
#line 616 "../core/Services/Database.vala"
	_g_free0 (_tmp34_);
#line 617 "../core/Services/Database.vala"
	_tmp35_ = stmt;
#line 617 "../core/Services/Database.vala"
	_tmp36_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
#line 617 "../core/Services/Database.vala"
	_tmp37_ = _tmp36_;
#line 617 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp35_, "$id", _tmp37_);
#line 619 "../core/Services/Database.vala"
	_tmp38_ = stmt;
#line 619 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp38_) != SQLITE_DONE) {
#line 1699 "Database.c"
		sqlite3* _tmp39_;
		sqlite3* _tmp40_;
		const gchar* _tmp41_;
#line 620 "../core/Services/Database.vala"
		_tmp39_ = self->priv->db;
#line 620 "../core/Services/Database.vala"
		_tmp40_ = self->priv->db;
#line 620 "../core/Services/Database.vala"
		_tmp41_ = sqlite3_errmsg (_tmp40_);
#line 620 "../core/Services/Database.vala"
		g_warning ("Database.vala:620: Error: %d: %s", sqlite3_errcode (_tmp39_), _tmp41_);
#line 1711 "Database.c"
	}
#line 623 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 623 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp42_) == SQLITE_DONE;
#line 623 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 623 "../core/Services/Database.vala"
	return result;
#line 1721 "Database.c"
}

GeeArrayList*
services_database_get_projects_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 630 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 631 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 631 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 635 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT * FROM Projects WHERE is_deleted = 0 ORDER BY child" \
"_order;\n" \
"        ");
#line 635 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 635 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 639 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 639 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 639 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 639 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 639 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 639 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 639 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 639 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 641 "../core/Services/Database.vala"
	while (TRUE) {
#line 1768 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
#line 641 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 641 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 641 "../core/Services/Database.vala"
			break;
#line 1780 "Database.c"
		}
#line 642 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 642 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 642 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_project (self, _tmp10_);
#line 642 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 642 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 642 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 1794 "Database.c"
	}
#line 645 "../core/Services/Database.vala"
	result = return_value;
#line 645 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 645 "../core/Services/Database.vala"
	return result;
#line 1802 "Database.c"
}

ObjectsProject*
_services_database_fill_project (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsProject* return_value = NULL;
	ObjectsProject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	ObjectsProject* result;
#line 648 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 648 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 649 "../core/Services/Database.vala"
	_tmp0_ = objects_project_new ();
#line 649 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 650 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 650 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 651 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 651 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 652 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 652 "../core/Services/Database.vala"
	objects_project_set_color (return_value, _tmp3_);
#line 653 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 653 "../core/Services/Database.vala"
	objects_project_set_backend_type (return_value, source_type_parse (_tmp4_));
#line 654 "../core/Services/Database.vala"
	objects_project_set_inbox_project (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 655 "../core/Services/Database.vala"
	objects_project_set_team_inbox (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 656 "../core/Services/Database.vala"
	objects_project_set_child_order (return_value, sqlite3_column_int (stmt, 6));
#line 657 "../core/Services/Database.vala"
	objects_project_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 658 "../core/Services/Database.vala"
	objects_project_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 659 "../core/Services/Database.vala"
	objects_project_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 9));
#line 660 "../core/Services/Database.vala"
	objects_project_set_shared (return_value, services_database_get_parameter_bool (self, stmt, 10));
#line 661 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 11);
#line 661 "../core/Services/Database.vala"
	objects_project_set_view_style (return_value, project_view_style_parse (_tmp5_));
#line 662 "../core/Services/Database.vala"
	objects_project_set_sort_order (return_value, sqlite3_column_int (stmt, 12));
#line 663 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 13);
#line 663 "../core/Services/Database.vala"
	objects_project_set_parent_id (return_value, _tmp6_);
#line 664 "../core/Services/Database.vala"
	objects_project_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 14));
#line 665 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 15);
#line 665 "../core/Services/Database.vala"
	objects_project_set_icon_style (return_value, project_icon_style_parse (_tmp7_));
#line 666 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 16);
#line 666 "../core/Services/Database.vala"
	objects_project_set_emoji (return_value, _tmp8_);
#line 667 "../core/Services/Database.vala"
	objects_project_set_show_completed (return_value, services_database_get_parameter_bool (self, stmt, 17));
#line 668 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 668 "../core/Services/Database.vala"
	objects_project_set_description (return_value, _tmp9_);
#line 669 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 19);
#line 669 "../core/Services/Database.vala"
	objects_project_set_due_date (return_value, _tmp10_);
#line 670 "../core/Services/Database.vala"
	objects_project_set_inbox_section_hidded (return_value, services_database_get_parameter_bool (self, stmt, 20));
#line 671 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 21);
#line 671 "../core/Services/Database.vala"
	objects_project_set_sync_id (return_value, _tmp11_);
#line 672 "../core/Services/Database.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (stmt, 22);
#line 672 "../core/Services/Database.vala"
	objects_project_set_source_id (return_value, _tmp12_);
#line 673 "../core/Services/Database.vala"
	result = return_value;
#line 673 "../core/Services/Database.vala"
	return result;
#line 1906 "Database.c"
}

gboolean
services_database_insert_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	SourceType _tmp17_;
	SourceType _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	sqlite3_stmt* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	sqlite3_stmt* _tmp42_;
	ProjectViewStyle _tmp43_;
	ProjectViewStyle _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	sqlite3_stmt* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	sqlite3_stmt* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	sqlite3_stmt* _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	sqlite3_stmt* _tmp56_;
	ProjectIconStyle _tmp57_;
	ProjectIconStyle _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	sqlite3_stmt* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	sqlite3_stmt* _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	sqlite3_stmt* _tmp82_;
	sqlite3_stmt* _tmp86_;
	gboolean result;
#line 676 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 676 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 679 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Projects (id, name, color, backend_t" \
"ype, inbox_project,\n" \
"                team_inbox, child_order, is_deleted, is_archived, is_f" \
"avorite, shared, view_style,\n" \
"                sort_order, parent_id, collapsed, icon_style, emoji, s" \
"how_completed, description, due_date,\n" \
"                inbox_section_hidded, sync_id, source_id)\n" \
"            VALUES ($id, $name, $color, $backend_type, $inbox_project," \
" $team_inbox,\n" \
"                $child_order, $is_deleted, $is_archived, $is_favorite," \
" $shared, $view_style,\n" \
"                $sort_order, $parent_id, $collapsed, $icon_style, $emo" \
"ji, $show_completed, $description, $due_date,\n" \
"                $inbox_section_hidded, $sync_id, $source_id);\n" \
"        ");
#line 679 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 679 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 690 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 690 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 690 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 690 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 690 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 690 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 690 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 690 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 691 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 691 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 691 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 691 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 692 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 692 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 692 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 692 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 693 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 693 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_color (project);
#line 693 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 693 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 694 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 694 "../core/Services/Database.vala"
	_tmp17_ = objects_project_get_backend_type (project);
#line 694 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 694 "../core/Services/Database.vala"
	_tmp19_ = source_type_to_string (_tmp18_);
#line 694 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 694 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$backend_type", _tmp20_);
#line 694 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 695 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 695 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_inbox_project (project);
#line 695 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 695 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$inbox_project", _tmp23_);
#line 696 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 696 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_team_inbox (project);
#line 696 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 696 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp24_, "$team_inbox", _tmp26_);
#line 697 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 697 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_child_order (project);
#line 697 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 697 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp27_, "$child_order", _tmp29_);
#line 698 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 698 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_deleted (project);
#line 698 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 698 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_deleted", _tmp32_);
#line 699 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 699 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_archived (project);
#line 699 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 699 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_archived", _tmp35_);
#line 700 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 700 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_is_favorite (project);
#line 700 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 700 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$is_favorite", _tmp38_);
#line 701 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 701 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_shared (project);
#line 701 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 701 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp39_, "$shared", _tmp41_);
#line 702 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 702 "../core/Services/Database.vala"
	_tmp43_ = objects_project_get_view_style (project);
#line 702 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 702 "../core/Services/Database.vala"
	_tmp45_ = project_view_style_to_string (_tmp44_);
#line 702 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 702 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp42_, "$view_style", _tmp46_);
#line 702 "../core/Services/Database.vala"
	_g_free0 (_tmp46_);
#line 703 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 703 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_sort_order (project);
#line 703 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 703 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp47_, "$sort_order", _tmp49_);
#line 704 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 704 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_parent_id (project);
#line 704 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 704 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp50_, "$parent_id", _tmp52_);
#line 705 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 705 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_collapsed (project);
#line 705 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 705 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp53_, "$collapsed", _tmp55_);
#line 706 "../core/Services/Database.vala"
	_tmp56_ = stmt;
#line 706 "../core/Services/Database.vala"
	_tmp57_ = objects_project_get_icon_style (project);
#line 706 "../core/Services/Database.vala"
	_tmp58_ = _tmp57_;
#line 706 "../core/Services/Database.vala"
	_tmp59_ = project_icon_style_to_string (_tmp58_);
#line 706 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 706 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp56_, "$icon_style", _tmp60_);
#line 706 "../core/Services/Database.vala"
	_g_free0 (_tmp60_);
#line 707 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 707 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_emoji (project);
#line 707 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 707 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$emoji", _tmp63_);
#line 708 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 708 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_show_completed (project);
#line 708 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 708 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp64_, "$show_completed", _tmp66_);
#line 709 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 709 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_description (project);
#line 709 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 709 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$description", _tmp69_);
#line 710 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 710 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_due_date (project);
#line 710 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 710 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp70_, "$due_date", _tmp72_);
#line 711 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 711 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_inbox_section_hidded (project);
#line 711 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 711 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp73_, "$inbox_section_hidded", _tmp75_);
#line 712 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 712 "../core/Services/Database.vala"
	_tmp77_ = objects_project_get_sync_id (project);
#line 712 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 712 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$sync_id", _tmp78_);
#line 713 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 713 "../core/Services/Database.vala"
	_tmp80_ = objects_project_get_source_id (project);
#line 713 "../core/Services/Database.vala"
	_tmp81_ = _tmp80_;
#line 713 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp79_, "$source_id", _tmp81_);
#line 715 "../core/Services/Database.vala"
	_tmp82_ = stmt;
#line 715 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp82_) != SQLITE_DONE) {
#line 2231 "Database.c"
		sqlite3* _tmp83_;
		sqlite3* _tmp84_;
		const gchar* _tmp85_;
#line 716 "../core/Services/Database.vala"
		_tmp83_ = self->priv->db;
#line 716 "../core/Services/Database.vala"
		_tmp84_ = self->priv->db;
#line 716 "../core/Services/Database.vala"
		_tmp85_ = sqlite3_errmsg (_tmp84_);
#line 716 "../core/Services/Database.vala"
		g_warning ("Database.vala:716: Error: %d: %s", sqlite3_errcode (_tmp83_), _tmp85_);
#line 2243 "Database.c"
	}
#line 719 "../core/Services/Database.vala"
	_tmp86_ = stmt;
#line 719 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp86_) == SQLITE_DONE;
#line 719 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 719 "../core/Services/Database.vala"
	return result;
#line 2253 "Database.c"
}

gboolean
services_database_delete_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 722 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 722 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 725 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Projects WHERE id=$id;\n        ");
#line 725 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 725 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 729 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 729 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 729 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 729 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 729 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 729 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 729 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 729 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 730 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 730 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 730 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 730 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 732 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 732 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 2312 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 733 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 733 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 733 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 733 "../core/Services/Database.vala"
		g_warning ("Database.vala:733: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 2324 "Database.c"
	}
#line 736 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 736 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 736 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 736 "../core/Services/Database.vala"
	return result;
#line 2334 "Database.c"
}

void
services_database_delete_project_db (ServicesDatabase* self,
                                     ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
#line 739 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 739 "../core/Services/Database.vala"
	g_return_if_fail (project != NULL);
#line 742 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            DELETE FROM Projects WHERE id=$id;\n" \
"            DELETE FROM Items WHERE project_id=$item_project_id;\n" \
"        ");
#line 742 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 742 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 747 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 747 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 747 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 747 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 747 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 747 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 747 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 747 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 748 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 748 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 748 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 748 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 749 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 749 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 749 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 749 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$section_project_id", _tmp12_);
#line 750 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 750 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 750 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 750 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$item_project_id", _tmp15_);
#line 752 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 752 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) != SQLITE_DONE) {
#line 2413 "Database.c"
		sqlite3* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 753 "../core/Services/Database.vala"
		_tmp17_ = self->priv->db;
#line 753 "../core/Services/Database.vala"
		_tmp18_ = self->priv->db;
#line 753 "../core/Services/Database.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 753 "../core/Services/Database.vala"
		g_warning ("Database.vala:753: Error: %d: %s", sqlite3_errcode (_tmp17_), _tmp19_);
#line 2425 "Database.c"
	}
#line 739 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2429 "Database.c"
}

gboolean
services_database_update_project (ServicesDatabase* self,
                                  ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	SourceType _tmp14_;
	SourceType _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	sqlite3_stmt* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	sqlite3_stmt* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	sqlite3_stmt* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	sqlite3_stmt* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	sqlite3_stmt* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	sqlite3_stmt* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	sqlite3_stmt* _tmp39_;
	ProjectViewStyle _tmp40_;
	ProjectViewStyle _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	sqlite3_stmt* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	sqlite3_stmt* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	sqlite3_stmt* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	sqlite3_stmt* _tmp53_;
	ProjectIconStyle _tmp54_;
	ProjectIconStyle _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	sqlite3_stmt* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	sqlite3_stmt* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	sqlite3_stmt* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	sqlite3_stmt* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	sqlite3_stmt* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	sqlite3_stmt* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	sqlite3_stmt* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	sqlite3_stmt* _tmp82_;
	sqlite3_stmt* _tmp86_;
	gboolean result;
#line 757 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 757 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 760 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET\n" \
"                name=$name,\n" \
"                color=$color,\n" \
"                backend_type=$backend_type,\n" \
"                inbox_project=$inbox_project,\n" \
"                team_inbox=$team_inbox,\n" \
"                child_order=$child_order,\n" \
"                is_deleted=$is_deleted,\n" \
"                is_archived=$is_archived,\n" \
"                is_favorite=$is_favorite,\n" \
"                shared=$shared,\n" \
"                view_style=$view_style,\n" \
"                sort_order=$sort_order,\n" \
"                parent_id=$parent_id,\n" \
"                collapsed=$collapsed,\n" \
"                icon_style=$icon_style,\n" \
"                emoji=$emoji,\n" \
"                show_completed=$show_completed,\n" \
"                description=$description,\n" \
"                due_date=$due_date,\n" \
"                inbox_section_hidded=$inbox_section_hidded,\n" \
"                sync_id=$sync_id,\n" \
"                source_id=$source_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 760 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 760 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 787 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 787 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 787 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 787 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 787 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 787 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 787 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 787 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 788 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 788 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
#line 788 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 788 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 789 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 789 "../core/Services/Database.vala"
	_tmp11_ = objects_project_get_color (project);
#line 789 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 789 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 790 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 790 "../core/Services/Database.vala"
	_tmp14_ = objects_project_get_backend_type (project);
#line 790 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 790 "../core/Services/Database.vala"
	_tmp16_ = source_type_to_string (_tmp15_);
#line 790 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 790 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$backend_type", _tmp17_);
#line 790 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 791 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 791 "../core/Services/Database.vala"
	_tmp19_ = objects_project_get_inbox_project (project);
#line 791 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 791 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp18_, "$inbox_project", _tmp20_);
#line 792 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 792 "../core/Services/Database.vala"
	_tmp22_ = objects_project_get_team_inbox (project);
#line 792 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 792 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp21_, "$team_inbox", _tmp23_);
#line 793 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 793 "../core/Services/Database.vala"
	_tmp25_ = objects_project_get_child_order (project);
#line 793 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 793 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp24_, "$child_order", _tmp26_);
#line 794 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 794 "../core/Services/Database.vala"
	_tmp28_ = objects_project_get_is_deleted (project);
#line 794 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 794 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp27_, "$is_deleted", _tmp29_);
#line 795 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 795 "../core/Services/Database.vala"
	_tmp31_ = objects_project_get_is_archived (project);
#line 795 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 795 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp30_, "$is_archived", _tmp32_);
#line 796 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 796 "../core/Services/Database.vala"
	_tmp34_ = objects_project_get_is_favorite (project);
#line 796 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 796 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp33_, "$is_favorite", _tmp35_);
#line 797 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 797 "../core/Services/Database.vala"
	_tmp37_ = objects_project_get_shared (project);
#line 797 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 797 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp36_, "$shared", _tmp38_);
#line 798 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 798 "../core/Services/Database.vala"
	_tmp40_ = objects_project_get_view_style (project);
#line 798 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 798 "../core/Services/Database.vala"
	_tmp42_ = project_view_style_to_string (_tmp41_);
#line 798 "../core/Services/Database.vala"
	_tmp43_ = _tmp42_;
#line 798 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp39_, "$view_style", _tmp43_);
#line 798 "../core/Services/Database.vala"
	_g_free0 (_tmp43_);
#line 799 "../core/Services/Database.vala"
	_tmp44_ = stmt;
#line 799 "../core/Services/Database.vala"
	_tmp45_ = objects_project_get_sort_order (project);
#line 799 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 799 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp44_, "$sort_order", _tmp46_);
#line 800 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 800 "../core/Services/Database.vala"
	_tmp48_ = objects_project_get_parent_id (project);
#line 800 "../core/Services/Database.vala"
	_tmp49_ = _tmp48_;
#line 800 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp47_, "$parent_id", _tmp49_);
#line 801 "../core/Services/Database.vala"
	_tmp50_ = stmt;
#line 801 "../core/Services/Database.vala"
	_tmp51_ = objects_project_get_collapsed (project);
#line 801 "../core/Services/Database.vala"
	_tmp52_ = _tmp51_;
#line 801 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp50_, "$collapsed", _tmp52_);
#line 802 "../core/Services/Database.vala"
	_tmp53_ = stmt;
#line 802 "../core/Services/Database.vala"
	_tmp54_ = objects_project_get_icon_style (project);
#line 802 "../core/Services/Database.vala"
	_tmp55_ = _tmp54_;
#line 802 "../core/Services/Database.vala"
	_tmp56_ = project_icon_style_to_string (_tmp55_);
#line 802 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 802 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp53_, "$icon_style", _tmp57_);
#line 802 "../core/Services/Database.vala"
	_g_free0 (_tmp57_);
#line 803 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 803 "../core/Services/Database.vala"
	_tmp59_ = objects_project_get_emoji (project);
#line 803 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 803 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp58_, "$emoji", _tmp60_);
#line 804 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 804 "../core/Services/Database.vala"
	_tmp62_ = objects_project_get_show_completed (project);
#line 804 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 804 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp61_, "$show_completed", _tmp63_);
#line 805 "../core/Services/Database.vala"
	_tmp64_ = stmt;
#line 805 "../core/Services/Database.vala"
	_tmp65_ = objects_project_get_description (project);
#line 805 "../core/Services/Database.vala"
	_tmp66_ = _tmp65_;
#line 805 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp64_, "$description", _tmp66_);
#line 806 "../core/Services/Database.vala"
	_tmp67_ = stmt;
#line 806 "../core/Services/Database.vala"
	_tmp68_ = objects_project_get_due_date (project);
#line 806 "../core/Services/Database.vala"
	_tmp69_ = _tmp68_;
#line 806 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp67_, "$due_date", _tmp69_);
#line 807 "../core/Services/Database.vala"
	_tmp70_ = stmt;
#line 807 "../core/Services/Database.vala"
	_tmp71_ = objects_project_get_inbox_section_hidded (project);
#line 807 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 807 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp70_, "$inbox_section_hidded", _tmp72_);
#line 808 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 808 "../core/Services/Database.vala"
	_tmp74_ = objects_project_get_sync_id (project);
#line 808 "../core/Services/Database.vala"
	_tmp75_ = _tmp74_;
#line 808 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp73_, "$sync_id", _tmp75_);
#line 809 "../core/Services/Database.vala"
	_tmp76_ = stmt;
#line 809 "../core/Services/Database.vala"
	_tmp77_ = objects_project_get_source_id (project);
#line 809 "../core/Services/Database.vala"
	_tmp78_ = _tmp77_;
#line 809 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp76_, "$source_id", _tmp78_);
#line 810 "../core/Services/Database.vala"
	_tmp79_ = stmt;
#line 810 "../core/Services/Database.vala"
	_tmp80_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 810 "../core/Services/Database.vala"
	_tmp81_ = _tmp80_;
#line 810 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp79_, "$id", _tmp81_);
#line 812 "../core/Services/Database.vala"
	_tmp82_ = stmt;
#line 812 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp82_) != SQLITE_DONE) {
#line 2754 "Database.c"
		sqlite3* _tmp83_;
		sqlite3* _tmp84_;
		const gchar* _tmp85_;
#line 813 "../core/Services/Database.vala"
		_tmp83_ = self->priv->db;
#line 813 "../core/Services/Database.vala"
		_tmp84_ = self->priv->db;
#line 813 "../core/Services/Database.vala"
		_tmp85_ = sqlite3_errmsg (_tmp84_);
#line 813 "../core/Services/Database.vala"
		g_warning ("Database.vala:813: Error: %d: %s", sqlite3_errcode (_tmp83_), _tmp85_);
#line 2766 "Database.c"
	}
#line 816 "../core/Services/Database.vala"
	_tmp86_ = stmt;
#line 816 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp86_) == SQLITE_DONE;
#line 816 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 816 "../core/Services/Database.vala"
	return result;
#line 2776 "Database.c"
}

gboolean
services_database_archive_project (ServicesDatabase* self,
                                   ObjectsProject* project)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 819 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 819 "../core/Services/Database.vala"
	g_return_val_if_fail (project != NULL, FALSE);
#line 822 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET is_archived=$is_archived WHERE id=$id;" \
"\n" \
"        ");
#line 822 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 822 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 826 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 826 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 826 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 826 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 826 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 826 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 826 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 826 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 827 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 827 "../core/Services/Database.vala"
	_tmp8_ = objects_project_get_is_archived (project);
#line 827 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 827 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$is_archived", _tmp9_);
#line 828 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 828 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
#line 828 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 828 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 830 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 830 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 2846 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 831 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 831 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 831 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 831 "../core/Services/Database.vala"
		g_warning ("Database.vala:831: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 2858 "Database.c"
	}
#line 834 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 834 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 834 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 834 "../core/Services/Database.vala"
	return result;
#line 2868 "Database.c"
}

GeeArrayList*
services_database_get_labels_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 841 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 842 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 842 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 845 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Labels;\n        ");
#line 845 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 845 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 849 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 849 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 849 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 849 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 849 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 849 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 849 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 849 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 851 "../core/Services/Database.vala"
	while (TRUE) {
#line 2915 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsLabel* _tmp11_;
		ObjectsLabel* _tmp12_;
#line 851 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 851 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 851 "../core/Services/Database.vala"
			break;
#line 2927 "Database.c"
		}
#line 852 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 852 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 852 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_label (self, _tmp10_);
#line 852 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 852 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 852 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 2941 "Database.c"
	}
#line 855 "../core/Services/Database.vala"
	result = return_value;
#line 855 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 855 "../core/Services/Database.vala"
	return result;
#line 2949 "Database.c"
}

ObjectsLabel*
_services_database_fill_label (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsLabel* return_value = NULL;
	ObjectsLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ObjectsLabel* result;
#line 858 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 858 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 859 "../core/Services/Database.vala"
	_tmp0_ = objects_label_new ();
#line 859 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 860 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 860 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 861 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 861 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 862 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 862 "../core/Services/Database.vala"
	objects_label_set_color (return_value, _tmp3_);
#line 863 "../core/Services/Database.vala"
	objects_label_set_item_order (return_value, sqlite3_column_int (stmt, 3));
#line 864 "../core/Services/Database.vala"
	objects_label_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 4));
#line 865 "../core/Services/Database.vala"
	objects_label_set_is_favorite (return_value, services_database_get_parameter_bool (self, stmt, 5));
#line 866 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 866 "../core/Services/Database.vala"
	objects_label_set_backend_type (return_value, source_type_parse (_tmp4_));
#line 867 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 867 "../core/Services/Database.vala"
	objects_label_set_source_id (return_value, _tmp5_);
#line 868 "../core/Services/Database.vala"
	result = return_value;
#line 868 "../core/Services/Database.vala"
	return result;
#line 3002 "Database.c"
}

gboolean
services_database_insert_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	SourceType _tmp26_;
	SourceType _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	sqlite3_stmt* _tmp37_;
	gboolean result;
#line 871 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 871 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 874 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Labels (id, name, color, item_order," \
"\n" \
"                is_deleted, is_favorite, backend_type, source_id)\n" \
"            VALUES ($id, $name, $color, $item_order,\n" \
"                $is_deleted, $is_favorite, $backend_type, $source_id);" \
"\n" \
"        ");
#line 874 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 874 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 881 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 881 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 881 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 881 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 881 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 881 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 881 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 881 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 882 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 882 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 882 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 882 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 883 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 883 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 883 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 883 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 884 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 884 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_color (label);
#line 884 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 884 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$color", _tmp15_);
#line 885 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 885 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_item_order (label);
#line 885 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 885 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp16_, "$item_order", _tmp18_);
#line 886 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 886 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_deleted (label);
#line 886 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 886 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_deleted", _tmp21_);
#line 887 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 887 "../core/Services/Database.vala"
	_tmp23_ = objects_label_get_is_favorite (label);
#line 887 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 887 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$is_favorite", _tmp24_);
#line 888 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 888 "../core/Services/Database.vala"
	_tmp26_ = objects_label_get_backend_type (label);
#line 888 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 888 "../core/Services/Database.vala"
	_tmp28_ = source_type_to_string (_tmp27_);
#line 888 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 888 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$backend_type", _tmp29_);
#line 888 "../core/Services/Database.vala"
	_g_free0 (_tmp29_);
#line 889 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 889 "../core/Services/Database.vala"
	_tmp31_ = objects_label_get_source_id (label);
#line 889 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 889 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$source_id", _tmp32_);
#line 891 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 891 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp33_) != SQLITE_DONE) {
#line 3146 "Database.c"
		sqlite3* _tmp34_;
		sqlite3* _tmp35_;
		const gchar* _tmp36_;
#line 892 "../core/Services/Database.vala"
		_tmp34_ = self->priv->db;
#line 892 "../core/Services/Database.vala"
		_tmp35_ = self->priv->db;
#line 892 "../core/Services/Database.vala"
		_tmp36_ = sqlite3_errmsg (_tmp35_);
#line 892 "../core/Services/Database.vala"
		g_warning ("Database.vala:892: Error: %d: %s", sqlite3_errcode (_tmp34_), _tmp36_);
#line 3158 "Database.c"
	}
#line 895 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 895 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp37_) == SQLITE_DONE;
#line 895 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 895 "../core/Services/Database.vala"
	return result;
#line 3168 "Database.c"
}

gboolean
services_database_delete_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 898 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 898 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 901 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Labels WHERE id=$id;\n        ");
#line 901 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 901 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 905 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 905 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 905 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 905 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 905 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 905 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 905 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 905 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 906 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 906 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 906 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 906 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 908 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 908 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 3227 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 909 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 909 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 909 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 909 "../core/Services/Database.vala"
		g_warning ("Database.vala:909: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 3239 "Database.c"
	}
#line 912 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 912 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 912 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 912 "../core/Services/Database.vala"
	return result;
#line 3249 "Database.c"
}

gboolean
services_database_update_label (ServicesDatabase* self,
                                ObjectsLabel* label)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	sqlite3_stmt* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp29_;
	gboolean result;
#line 915 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 915 "../core/Services/Database.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 918 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Labels SET name=$name, color=$color, item_order=$it" \
"em_order,\n" \
"                is_deleted=$is_deleted, is_favorite=$is_favorite\n" \
"            WHERE id=$id;\n" \
"        ");
#line 918 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 918 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 924 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 924 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 924 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 924 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 924 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 924 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 924 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 924 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 925 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 925 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) label);
#line 925 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 925 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 926 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 926 "../core/Services/Database.vala"
	_tmp11_ = objects_label_get_color (label);
#line 926 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 926 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$color", _tmp12_);
#line 927 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 927 "../core/Services/Database.vala"
	_tmp14_ = objects_label_get_item_order (label);
#line 927 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 927 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp13_, "$item_order", _tmp15_);
#line 928 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 928 "../core/Services/Database.vala"
	_tmp17_ = objects_label_get_is_deleted (label);
#line 928 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 928 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp16_, "$is_deleted", _tmp18_);
#line 929 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 929 "../core/Services/Database.vala"
	_tmp20_ = objects_label_get_is_favorite (label);
#line 929 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 929 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp19_, "$is_favorite", _tmp21_);
#line 930 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 930 "../core/Services/Database.vala"
	_tmp23_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
#line 930 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 930 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$id", _tmp24_);
#line 932 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 932 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 3363 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 933 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 933 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 933 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 933 "../core/Services/Database.vala"
		g_warning ("Database.vala:933: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 3375 "Database.c"
	}
#line 936 "../core/Services/Database.vala"
	_tmp29_ = stmt;
#line 936 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp29_) == SQLITE_DONE;
#line 936 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 936 "../core/Services/Database.vala"
	return result;
#line 3385 "Database.c"
}

gboolean
services_database_insert_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp47_;
	gboolean result;
#line 943 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 943 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 946 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Sections (id, name, archived_at, add" \
"ed_at, project_id, section_order,\n" \
"            collapsed, is_deleted, is_archived, color, description, hi" \
"dded)\n" \
"            VALUES ($id, $name, $archived_at, $added_at, $project_id, " \
"$section_order,\n" \
"            $collapsed, $is_deleted, $is_archived, $color, $descriptio" \
"n, $hidded);\n" \
"        ");
#line 946 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 946 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 953 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 953 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 953 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 953 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 953 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 953 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 953 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 953 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 954 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 954 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 954 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 954 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 955 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 955 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 955 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 955 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$name", _tmp12_);
#line 956 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 956 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_archived_at (section);
#line 956 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 956 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$archived_at", _tmp15_);
#line 957 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 957 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_added_at (section);
#line 957 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 957 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$added_at", _tmp18_);
#line 958 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 958 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_project_id (section);
#line 958 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 958 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$project_id", _tmp21_);
#line 959 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 959 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_section_order (section);
#line 959 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 959 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp22_, "$section_order", _tmp24_);
#line 960 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 960 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_collapsed (section);
#line 960 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 960 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$collapsed", _tmp27_);
#line 961 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 961 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_deleted (section);
#line 961 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 961 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_deleted", _tmp30_);
#line 962 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 962 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_is_archived (section);
#line 962 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 962 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp31_, "$is_archived", _tmp33_);
#line 963 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 963 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_color (section);
#line 963 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 963 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$color", _tmp36_);
#line 964 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 964 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_description (section);
#line 964 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 964 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$description", _tmp39_);
#line 965 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 965 "../core/Services/Database.vala"
	_tmp41_ = objects_section_get_hidded (section);
#line 965 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 965 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp40_, "$hidded", _tmp42_);
#line 967 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 967 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) != SQLITE_DONE) {
#line 3565 "Database.c"
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 968 "../core/Services/Database.vala"
		_tmp44_ = self->priv->db;
#line 968 "../core/Services/Database.vala"
		_tmp45_ = self->priv->db;
#line 968 "../core/Services/Database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 968 "../core/Services/Database.vala"
		g_warning ("Database.vala:968: Error: %d: %s", sqlite3_errcode (_tmp44_), _tmp46_);
#line 3577 "Database.c"
	}
#line 971 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 971 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp47_) == SQLITE_DONE;
#line 971 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 971 "../core/Services/Database.vala"
	return result;
#line 3587 "Database.c"
}

GeeArrayList*
services_database_get_sections_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 974 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 975 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 975 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 978 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Sections WHERE is_deleted = 0;");
#line 978 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 978 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 980 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 980 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 980 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 980 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 980 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 980 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 980 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 980 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 982 "../core/Services/Database.vala"
	while (TRUE) {
#line 3634 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsSection* _tmp11_;
		ObjectsSection* _tmp12_;
#line 982 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 982 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 982 "../core/Services/Database.vala"
			break;
#line 3646 "Database.c"
		}
#line 983 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 983 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 983 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_section (self, _tmp10_);
#line 983 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 983 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 983 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 3660 "Database.c"
	}
#line 986 "../core/Services/Database.vala"
	result = return_value;
#line 986 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 986 "../core/Services/Database.vala"
	return result;
#line 3668 "Database.c"
}

ObjectsSection*
_services_database_fill_section (ServicesDatabase* self,
                                 sqlite3_stmt* stmt)
{
	ObjectsSection* return_value = NULL;
	ObjectsSection* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	ObjectsSection* result;
#line 989 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 989 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 990 "../core/Services/Database.vala"
	_tmp0_ = objects_section_new ();
#line 990 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 991 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 991 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 992 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 992 "../core/Services/Database.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) return_value, _tmp2_);
#line 993 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 993 "../core/Services/Database.vala"
	objects_section_set_archived_at (return_value, _tmp3_);
#line 994 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 994 "../core/Services/Database.vala"
	objects_section_set_added_at (return_value, _tmp4_);
#line 995 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 995 "../core/Services/Database.vala"
	objects_section_set_project_id (return_value, _tmp5_);
#line 996 "../core/Services/Database.vala"
	objects_section_set_section_order (return_value, sqlite3_column_int (stmt, 5));
#line 997 "../core/Services/Database.vala"
	objects_section_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 6));
#line 998 "../core/Services/Database.vala"
	objects_section_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 7));
#line 999 "../core/Services/Database.vala"
	objects_section_set_is_archived (return_value, services_database_get_parameter_bool (self, stmt, 8));
#line 1000 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1000 "../core/Services/Database.vala"
	objects_section_set_color (return_value, _tmp6_);
#line 1001 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 10);
#line 1001 "../core/Services/Database.vala"
	objects_section_set_description (return_value, _tmp7_);
#line 1002 "../core/Services/Database.vala"
	objects_section_set_hidded (return_value, services_database_get_parameter_bool (self, stmt, 11));
#line 1003 "../core/Services/Database.vala"
	result = return_value;
#line 1003 "../core/Services/Database.vala"
	return result;
#line 3735 "Database.c"
}

gboolean
services_database_delete_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1006 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1006 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1009 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Sections WHERE id=$id;\n        ");
#line 1009 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1009 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1013 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1013 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1013 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1013 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1013 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1013 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1013 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1013 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1014 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1014 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1014 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1014 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1016 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1016 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 3794 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1017 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1017 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1017 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1017 "../core/Services/Database.vala"
		g_warning ("Database.vala:1017: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 3806 "Database.c"
	}
#line 1020 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1020 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1020 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1020 "../core/Services/Database.vala"
	return result;
#line 3816 "Database.c"
}

gboolean
services_database_update_section (ServicesDatabase* self,
                                  ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	sqlite3_stmt* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	sqlite3_stmt* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	sqlite3_stmt* _tmp43_;
	sqlite3_stmt* _tmp47_;
	gboolean result;
#line 1023 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1023 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1026 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET name=$name, archived_at=$archived_at, " \
"added_at=$added_at,\n" \
"                project_id=$project_id, section_order=$section_order, " \
"collapsed=$collapsed,\n" \
"                is_deleted=$is_deleted, is_archived=$is_archived, colo" \
"r=$color, description=$description,\n" \
"                hidded=$hidded\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1026 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1026 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1034 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1034 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1034 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1034 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1034 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1034 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1034 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1034 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1035 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1035 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_name ((ObjectsBaseObject*) section);
#line 1035 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1035 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$name", _tmp9_);
#line 1036 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1036 "../core/Services/Database.vala"
	_tmp11_ = objects_section_get_archived_at (section);
#line 1036 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1036 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$archived_at", _tmp12_);
#line 1037 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1037 "../core/Services/Database.vala"
	_tmp14_ = objects_section_get_added_at (section);
#line 1037 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1037 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$added_at", _tmp15_);
#line 1038 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1038 "../core/Services/Database.vala"
	_tmp17_ = objects_section_get_project_id (section);
#line 1038 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1038 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$project_id", _tmp18_);
#line 1039 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1039 "../core/Services/Database.vala"
	_tmp20_ = objects_section_get_section_order (section);
#line 1039 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1039 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp19_, "$section_order", _tmp21_);
#line 1040 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1040 "../core/Services/Database.vala"
	_tmp23_ = objects_section_get_collapsed (section);
#line 1040 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1040 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp22_, "$collapsed", _tmp24_);
#line 1041 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1041 "../core/Services/Database.vala"
	_tmp26_ = objects_section_get_is_deleted (section);
#line 1041 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1041 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp25_, "$is_deleted", _tmp27_);
#line 1042 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1042 "../core/Services/Database.vala"
	_tmp29_ = objects_section_get_is_archived (section);
#line 1042 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1042 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp28_, "$is_archived", _tmp30_);
#line 1043 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1043 "../core/Services/Database.vala"
	_tmp32_ = objects_section_get_color (section);
#line 1043 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1043 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$color", _tmp33_);
#line 1044 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1044 "../core/Services/Database.vala"
	_tmp35_ = objects_section_get_description (section);
#line 1044 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1044 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$description", _tmp36_);
#line 1045 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1045 "../core/Services/Database.vala"
	_tmp38_ = objects_section_get_hidded (section);
#line 1045 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1045 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp37_, "$hidded", _tmp39_);
#line 1046 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1046 "../core/Services/Database.vala"
	_tmp41_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1046 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1046 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp40_, "$id", _tmp42_);
#line 1048 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1048 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp43_) != SQLITE_DONE) {
#line 3996 "Database.c"
		sqlite3* _tmp44_;
		sqlite3* _tmp45_;
		const gchar* _tmp46_;
#line 1049 "../core/Services/Database.vala"
		_tmp44_ = self->priv->db;
#line 1049 "../core/Services/Database.vala"
		_tmp45_ = self->priv->db;
#line 1049 "../core/Services/Database.vala"
		_tmp46_ = sqlite3_errmsg (_tmp45_);
#line 1049 "../core/Services/Database.vala"
		g_warning ("Database.vala:1049: Error: %d: %s", sqlite3_errcode (_tmp44_), _tmp46_);
#line 4008 "Database.c"
	}
#line 1052 "../core/Services/Database.vala"
	_tmp47_ = stmt;
#line 1052 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp47_) == SQLITE_DONE;
#line 1052 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1052 "../core/Services/Database.vala"
	return result;
#line 4018 "Database.c"
}

gboolean
services_database_move_section (ServicesDatabase* self,
                                ObjectsSection* section,
                                const gchar* old_project_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1055 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1055 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1055 "../core/Services/Database.vala"
	g_return_val_if_fail (old_project_id != NULL, FALSE);
#line 1058 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET project_id=$project_id WHERE id=$id;\n" \
"        ");
#line 1058 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1058 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1062 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1062 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1062 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1062 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1062 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1062 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1062 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1062 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1063 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1063 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_project_id (section);
#line 1063 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1063 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$project_id", _tmp9_);
#line 1064 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1064 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1064 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1064 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1066 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1066 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4091 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1067 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1067 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1067 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1067 "../core/Services/Database.vala"
		g_warning ("Database.vala:1067: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4103 "Database.c"
	}
#line 1070 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1070 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1070 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1070 "../core/Services/Database.vala"
	return result;
#line 4113 "Database.c"
}

gboolean
services_database_move_section_items (ServicesDatabase* self,
                                      ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1073 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1073 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1076 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET project_id=$project_id WHERE section_id=$" \
"section_id;\n" \
"        ");
#line 1076 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1076 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1080 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1080 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1080 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1080 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1080 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1080 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1080 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1080 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1081 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1081 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_project_id (section);
#line 1081 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1081 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$project_id", _tmp9_);
#line 1082 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1082 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1082 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1082 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$section_id", _tmp12_);
#line 1084 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1084 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4183 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1085 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1085 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1085 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1085 "../core/Services/Database.vala"
		g_warning ("Database.vala:1085: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4195 "Database.c"
	}
#line 1089 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1089 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1089 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1089 "../core/Services/Database.vala"
	return result;
#line 4205 "Database.c"
}

gboolean
services_database_archive_section (ServicesDatabase* self,
                                   ObjectsSection* section)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp17_;
	gboolean result;
#line 1092 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1092 "../core/Services/Database.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 1095 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET is_archived=$is_archived WHERE id=$id;" \
"\n" \
"        ");
#line 1095 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1095 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1099 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1099 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1099 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1099 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1099 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1099 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1099 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1099 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1100 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1100 "../core/Services/Database.vala"
	_tmp8_ = objects_section_get_is_archived (section);
#line 1100 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1100 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$is_archived", _tmp9_);
#line 1101 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1101 "../core/Services/Database.vala"
	_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) section);
#line 1101 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1101 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$id", _tmp12_);
#line 1103 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1103 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp13_) != SQLITE_DONE) {
#line 4275 "Database.c"
		sqlite3* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_;
#line 1104 "../core/Services/Database.vala"
		_tmp14_ = self->priv->db;
#line 1104 "../core/Services/Database.vala"
		_tmp15_ = self->priv->db;
#line 1104 "../core/Services/Database.vala"
		_tmp16_ = sqlite3_errmsg (_tmp15_);
#line 1104 "../core/Services/Database.vala"
		g_warning ("Database.vala:1104: Error: %d: %s", sqlite3_errcode (_tmp14_), _tmp16_);
#line 4287 "Database.c"
	}
#line 1108 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1108 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp17_) == SQLITE_DONE;
#line 1108 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1108 "../core/Services/Database.vala"
	return result;
#line 4297 "Database.c"
}

gboolean
services_database_insert_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               gboolean insert)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	ObjectsDueDate* _tmp17_;
	ObjectsDueDate* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	sqlite3_stmt* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	sqlite3_stmt* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	sqlite3_stmt* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	sqlite3_stmt* _tmp45_;
	gboolean _tmp46_;
	gboolean _tmp47_;
	sqlite3_stmt* _tmp48_;
	gboolean _tmp49_;
	gboolean _tmp50_;
	sqlite3_stmt* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	sqlite3_stmt* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	sqlite3_stmt* _tmp57_;
	gboolean _tmp58_;
	gboolean _tmp59_;
	sqlite3_stmt* _tmp60_;
	GeeArrayList* _tmp61_;
	GeeArrayList* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	sqlite3_stmt* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	sqlite3_stmt* _tmp68_;
	ItemType _tmp69_;
	ItemType _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	sqlite3_stmt* _tmp73_;
	sqlite3_stmt* _tmp77_;
	gboolean result;
#line 1115 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1115 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1118 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Items (id, content, description, due" \
", added_at, completed_at,\n" \
"                updated_at, section_id, project_id, parent_id, priorit" \
"y, child_order,\n" \
"                checked, is_deleted, day_order, collapsed, pinned, lab" \
"els, extra_data, item_type)\n" \
"            VALUES ($id, $content, $description, $due, $added_at, $com" \
"pleted_at,\n" \
"                $updated_at, $section_id, $project_id, $parent_id, $pr" \
"iority, $child_order,\n" \
"                $checked, $is_deleted, $day_order, $collapsed, $pinned" \
", $labels, $extra_data, $item_type);\n" \
"        ");
#line 1118 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1118 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1127 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1127 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1127 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1127 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1127 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1127 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1127 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1127 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1128 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1128 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1128 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1128 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1129 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1129 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_content (item);
#line 1129 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1129 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$content", _tmp12_);
#line 1130 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1130 "../core/Services/Database.vala"
	_tmp14_ = objects_item_get_description (item);
#line 1130 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1130 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$description", _tmp15_);
#line 1131 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1131 "../core/Services/Database.vala"
	_tmp17_ = objects_item_get_due (item);
#line 1131 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1131 "../core/Services/Database.vala"
	_tmp19_ = objects_due_date_to_string (_tmp18_);
#line 1131 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 1131 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$due", _tmp20_);
#line 1131 "../core/Services/Database.vala"
	_g_free0 (_tmp20_);
#line 1132 "../core/Services/Database.vala"
	_tmp21_ = stmt;
#line 1132 "../core/Services/Database.vala"
	_tmp22_ = objects_item_get_added_at (item);
#line 1132 "../core/Services/Database.vala"
	_tmp23_ = _tmp22_;
#line 1132 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp21_, "$added_at", _tmp23_);
#line 1133 "../core/Services/Database.vala"
	_tmp24_ = stmt;
#line 1133 "../core/Services/Database.vala"
	_tmp25_ = objects_item_get_completed_at (item);
#line 1133 "../core/Services/Database.vala"
	_tmp26_ = _tmp25_;
#line 1133 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp24_, "$completed_at", _tmp26_);
#line 1134 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 1134 "../core/Services/Database.vala"
	_tmp28_ = objects_item_get_updated_at (item);
#line 1134 "../core/Services/Database.vala"
	_tmp29_ = _tmp28_;
#line 1134 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp27_, "$updated_at", _tmp29_);
#line 1135 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1135 "../core/Services/Database.vala"
	_tmp31_ = objects_item_get_section_id (item);
#line 1135 "../core/Services/Database.vala"
	_tmp32_ = _tmp31_;
#line 1135 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp30_, "$section_id", _tmp32_);
#line 1136 "../core/Services/Database.vala"
	_tmp33_ = stmt;
#line 1136 "../core/Services/Database.vala"
	_tmp34_ = objects_item_get_project_id (item);
#line 1136 "../core/Services/Database.vala"
	_tmp35_ = _tmp34_;
#line 1136 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp33_, "$project_id", _tmp35_);
#line 1137 "../core/Services/Database.vala"
	_tmp36_ = stmt;
#line 1137 "../core/Services/Database.vala"
	_tmp37_ = objects_item_get_parent_id (item);
#line 1137 "../core/Services/Database.vala"
	_tmp38_ = _tmp37_;
#line 1137 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp36_, "$parent_id", _tmp38_);
#line 1138 "../core/Services/Database.vala"
	_tmp39_ = stmt;
#line 1138 "../core/Services/Database.vala"
	_tmp40_ = objects_item_get_priority (item);
#line 1138 "../core/Services/Database.vala"
	_tmp41_ = _tmp40_;
#line 1138 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp39_, "$priority", _tmp41_);
#line 1139 "../core/Services/Database.vala"
	_tmp42_ = stmt;
#line 1139 "../core/Services/Database.vala"
	_tmp43_ = objects_item_get_child_order (item);
#line 1139 "../core/Services/Database.vala"
	_tmp44_ = _tmp43_;
#line 1139 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp42_, "$child_order", _tmp44_);
#line 1140 "../core/Services/Database.vala"
	_tmp45_ = stmt;
#line 1140 "../core/Services/Database.vala"
	_tmp46_ = objects_item_get_checked (item);
#line 1140 "../core/Services/Database.vala"
	_tmp47_ = _tmp46_;
#line 1140 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp45_, "$checked", _tmp47_);
#line 1141 "../core/Services/Database.vala"
	_tmp48_ = stmt;
#line 1141 "../core/Services/Database.vala"
	_tmp49_ = objects_item_get_is_deleted (item);
#line 1141 "../core/Services/Database.vala"
	_tmp50_ = _tmp49_;
#line 1141 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp48_, "$is_deleted", _tmp50_);
#line 1142 "../core/Services/Database.vala"
	_tmp51_ = stmt;
#line 1142 "../core/Services/Database.vala"
	_tmp52_ = objects_item_get_day_order (item);
#line 1142 "../core/Services/Database.vala"
	_tmp53_ = _tmp52_;
#line 1142 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp51_, "$day_order", _tmp53_);
#line 1143 "../core/Services/Database.vala"
	_tmp54_ = stmt;
#line 1143 "../core/Services/Database.vala"
	_tmp55_ = objects_item_get_collapsed (item);
#line 1143 "../core/Services/Database.vala"
	_tmp56_ = _tmp55_;
#line 1143 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp54_, "$collapsed", _tmp56_);
#line 1144 "../core/Services/Database.vala"
	_tmp57_ = stmt;
#line 1144 "../core/Services/Database.vala"
	_tmp58_ = objects_item_get_pinned (item);
#line 1144 "../core/Services/Database.vala"
	_tmp59_ = _tmp58_;
#line 1144 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp57_, "$pinned", _tmp59_);
#line 1145 "../core/Services/Database.vala"
	_tmp60_ = stmt;
#line 1145 "../core/Services/Database.vala"
	_tmp61_ = objects_item_get_labels (item);
#line 1145 "../core/Services/Database.vala"
	_tmp62_ = _tmp61_;
#line 1145 "../core/Services/Database.vala"
	_tmp63_ = services_database_get_labels_ids (self, _tmp62_);
#line 1145 "../core/Services/Database.vala"
	_tmp64_ = _tmp63_;
#line 1145 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp60_, "$labels", _tmp64_);
#line 1145 "../core/Services/Database.vala"
	_g_free0 (_tmp64_);
#line 1146 "../core/Services/Database.vala"
	_tmp65_ = stmt;
#line 1146 "../core/Services/Database.vala"
	_tmp66_ = objects_item_get_extra_data (item);
#line 1146 "../core/Services/Database.vala"
	_tmp67_ = _tmp66_;
#line 1146 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp65_, "$extra_data", _tmp67_);
#line 1147 "../core/Services/Database.vala"
	_tmp68_ = stmt;
#line 1147 "../core/Services/Database.vala"
	_tmp69_ = objects_item_get_item_type (item);
#line 1147 "../core/Services/Database.vala"
	_tmp70_ = _tmp69_;
#line 1147 "../core/Services/Database.vala"
	_tmp71_ = item_type_to_string (_tmp70_);
#line 1147 "../core/Services/Database.vala"
	_tmp72_ = _tmp71_;
#line 1147 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp68_, "$item_type", _tmp72_);
#line 1147 "../core/Services/Database.vala"
	_g_free0 (_tmp72_);
#line 1149 "../core/Services/Database.vala"
	_tmp73_ = stmt;
#line 1149 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp73_) != SQLITE_DONE) {
#line 4590 "Database.c"
		sqlite3* _tmp74_;
		sqlite3* _tmp75_;
		const gchar* _tmp76_;
#line 1150 "../core/Services/Database.vala"
		_tmp74_ = self->priv->db;
#line 1150 "../core/Services/Database.vala"
		_tmp75_ = self->priv->db;
#line 1150 "../core/Services/Database.vala"
		_tmp76_ = sqlite3_errmsg (_tmp75_);
#line 1150 "../core/Services/Database.vala"
		g_warning ("Database.vala:1150: Error: %d: %s", sqlite3_errcode (_tmp74_), _tmp76_);
#line 4602 "Database.c"
	}
#line 1153 "../core/Services/Database.vala"
	_tmp77_ = stmt;
#line 1153 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp77_) == SQLITE_DONE;
#line 1153 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1153 "../core/Services/Database.vala"
	return result;
#line 4612 "Database.c"
}

GeeArrayList*
services_database_get_items_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1156 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1157 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1157 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1160 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE is_deleted = 0;");
#line 1160 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1160 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1162 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1162 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1162 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1162 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1162 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1162 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1162 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1162 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1164 "../core/Services/Database.vala"
	while (TRUE) {
#line 4659 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
		ObjectsItem* _tmp12_;
#line 1164 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1164 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1164 "../core/Services/Database.vala"
			break;
#line 4671 "Database.c"
		}
#line 1165 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1165 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1165 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1165 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1165 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1165 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 4685 "Database.c"
	}
#line 1168 "../core/Services/Database.vala"
	result = return_value;
#line 1168 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1168 "../core/Services/Database.vala"
	return result;
#line 4693 "Database.c"
}

ObjectsItem*
services_database_get_item_by_id (ServicesDatabase* self,
                                  const gchar* id)
{
	ObjectsItem* returned = NULL;
	ObjectsItem* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	ObjectsItem* result;
#line 1171 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1171 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1172 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1172 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1175 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("SELECT * FROM Items WHERE id = $id LIMIT 1;");
#line 1175 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1175 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1177 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1177 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1177 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1177 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1177 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1177 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1177 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1177 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1178 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1178 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1180 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1180 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 4751 "Database.c"
		sqlite3_stmt* _tmp10_;
		ObjectsItem* _tmp11_;
#line 1181 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1181 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_item (self, _tmp10_);
#line 1181 "../core/Services/Database.vala"
		_g_object_unref0 (returned);
#line 1181 "../core/Services/Database.vala"
		returned = _tmp11_;
#line 4762 "Database.c"
	}
#line 1185 "../core/Services/Database.vala"
	result = returned;
#line 1185 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1185 "../core/Services/Database.vala"
	return result;
#line 4770 "Database.c"
}

ObjectsItem*
_services_database_fill_item (ServicesDatabase* self,
                              sqlite3_stmt* stmt)
{
	ObjectsItem* return_value = NULL;
	ObjectsItem* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	ObjectsDueDate* _tmp4_;
	ObjectsDueDate* _tmp5_;
	const gchar* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	ServicesStore* _tmp15_;
	const gchar* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	ObjectsItem* result;
#line 1188 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1188 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1189 "../core/Services/Database.vala"
	_tmp0_ = objects_item_new ();
#line 1189 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1190 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1190 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) return_value, _tmp1_);
#line 1191 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1191 "../core/Services/Database.vala"
	objects_item_set_content (return_value, _tmp2_);
#line 1192 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1192 "../core/Services/Database.vala"
	objects_item_set_description (return_value, _tmp3_);
#line 1193 "../core/Services/Database.vala"
	_tmp4_ = objects_item_get_due (return_value);
#line 1193 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1193 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1193 "../core/Services/Database.vala"
	_tmp7_ = services_database_get_due_parameter (self, _tmp6_);
#line 1193 "../core/Services/Database.vala"
	_tmp8_ = _tmp7_;
#line 1193 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp5_, _tmp8_);
#line 1193 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp8_);
#line 1194 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1194 "../core/Services/Database.vala"
	objects_item_set_added_at (return_value, _tmp9_);
#line 1195 "../core/Services/Database.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1195 "../core/Services/Database.vala"
	objects_item_set_completed_at (return_value, _tmp10_);
#line 1196 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 1196 "../core/Services/Database.vala"
	objects_item_set_updated_at (return_value, _tmp11_);
#line 1197 "../core/Services/Database.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 1197 "../core/Services/Database.vala"
	objects_item_set_section_id (return_value, _tmp12_);
#line 1198 "../core/Services/Database.vala"
	_tmp13_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 1198 "../core/Services/Database.vala"
	objects_item_set_project_id (return_value, _tmp13_);
#line 1199 "../core/Services/Database.vala"
	_tmp14_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1199 "../core/Services/Database.vala"
	objects_item_set_parent_id (return_value, _tmp14_);
#line 1200 "../core/Services/Database.vala"
	objects_item_set_priority (return_value, sqlite3_column_int (stmt, 10));
#line 1201 "../core/Services/Database.vala"
	objects_item_set_child_order (return_value, sqlite3_column_int (stmt, 11));
#line 1202 "../core/Services/Database.vala"
	objects_item_set_checked (return_value, services_database_get_parameter_bool (self, stmt, 12));
#line 1203 "../core/Services/Database.vala"
	objects_item_set_is_deleted (return_value, services_database_get_parameter_bool (self, stmt, 13));
#line 1204 "../core/Services/Database.vala"
	objects_item_set_day_order (return_value, sqlite3_column_int (stmt, 14));
#line 1205 "../core/Services/Database.vala"
	objects_item_set_collapsed (return_value, services_database_get_parameter_bool (self, stmt, 15));
#line 1206 "../core/Services/Database.vala"
	objects_item_set_pinned (return_value, services_database_get_parameter_bool (self, stmt, 16));
#line 1207 "../core/Services/Database.vala"
	_tmp15_ = services_store_instance ();
#line 1207 "../core/Services/Database.vala"
	_tmp16_ = (const gchar*) sqlite3_column_text (stmt, 17);
#line 1207 "../core/Services/Database.vala"
	_tmp17_ = services_store_get_labels_by_item_labels (_tmp15_, _tmp16_);
#line 1207 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1207 "../core/Services/Database.vala"
	objects_item_set_labels (return_value, _tmp18_);
#line 1207 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp18_);
#line 1208 "../core/Services/Database.vala"
	_tmp19_ = (const gchar*) sqlite3_column_text (stmt, 18);
#line 1208 "../core/Services/Database.vala"
	objects_item_set_extra_data (return_value, _tmp19_);
#line 1209 "../core/Services/Database.vala"
	_tmp20_ = (const gchar*) sqlite3_column_text (stmt, 19);
#line 1209 "../core/Services/Database.vala"
	objects_item_set_item_type (return_value, item_type_parse (_tmp20_));
#line 1211 "../core/Services/Database.vala"
	result = return_value;
#line 1211 "../core/Services/Database.vala"
	return result;
#line 4896 "Database.c"
}

gboolean
services_database_delete_item (ServicesDatabase* self,
                               ObjectsItem* item)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1214 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1214 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1217 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Items WHERE id=$id;\n        ");
#line 1217 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1217 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1221 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1221 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1221 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1221 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1221 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1221 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1221 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1221 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1222 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1222 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1222 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1222 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1224 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1224 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 4955 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1225 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1225 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1225 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1225 "../core/Services/Database.vala"
		g_warning ("Database.vala:1225: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 4967 "Database.c"
	}
#line 1229 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1229 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1229 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1229 "../core/Services/Database.vala"
	return result;
#line 4977 "Database.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 4993 "Database.c"
}

gboolean
services_database_update_item (ServicesDatabase* self,
                               ObjectsItem* item,
                               const gchar* update_id)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	ObjectsDueDate* _tmp18_;
	ObjectsDueDate* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	sqlite3_stmt* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	sqlite3_stmt* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	sqlite3_stmt* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	sqlite3_stmt* _tmp49_;
	gboolean _tmp50_;
	gboolean _tmp51_;
	sqlite3_stmt* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	sqlite3_stmt* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	sqlite3_stmt* _tmp61_;
	GeeArrayList* _tmp62_;
	GeeArrayList* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	sqlite3_stmt* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	sqlite3_stmt* _tmp69_;
	ItemType _tmp70_;
	ItemType _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	sqlite3_stmt* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	sqlite3_stmt* _tmp77_;
	sqlite3_stmt* _tmp81_;
	gboolean result;
#line 1232 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1232 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1232 "../core/Services/Database.vala"
	g_return_val_if_fail (update_id != NULL, FALSE);
#line 1233 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1233 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1233 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1233 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1233 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1233 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1233 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1236 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET content=$content, description=$descriptio" \
"n, due=$due,\n" \
"                added_at=$added_at, completed_at=$completed_at, update" \
"d_at=$updated_at,\n" \
"                section_id=$section_id, project_id=$project_id, parent" \
"_id=$parent_id,\n" \
"                priority=$priority, child_order=$child_order, checked=" \
"$checked,\n" \
"                is_deleted=$is_deleted, day_order=$day_order, collapse" \
"d=$collapsed,\n" \
"                pinned=$pinned, labels=$labels, extra_data=$extra_data" \
", item_type=$item_type\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1236 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1236 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1246 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1246 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1246 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1246 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1246 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1246 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1246 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1246 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1247 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1247 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_content (item);
#line 1247 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1247 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$content", _tmp13_);
#line 1248 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1248 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_description (item);
#line 1248 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1248 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$description", _tmp16_);
#line 1249 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1249 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_due (item);
#line 1249 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1249 "../core/Services/Database.vala"
	_tmp20_ = objects_due_date_to_string (_tmp19_);
#line 1249 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1249 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$due", _tmp21_);
#line 1249 "../core/Services/Database.vala"
	_g_free0 (_tmp21_);
#line 1250 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1250 "../core/Services/Database.vala"
	_tmp23_ = objects_item_get_added_at (item);
#line 1250 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1250 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$added_at", _tmp24_);
#line 1251 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1251 "../core/Services/Database.vala"
	_tmp26_ = objects_item_get_completed_at (item);
#line 1251 "../core/Services/Database.vala"
	_tmp27_ = _tmp26_;
#line 1251 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp25_, "$completed_at", _tmp27_);
#line 1252 "../core/Services/Database.vala"
	_tmp28_ = stmt;
#line 1252 "../core/Services/Database.vala"
	_tmp29_ = objects_item_get_updated_at (item);
#line 1252 "../core/Services/Database.vala"
	_tmp30_ = _tmp29_;
#line 1252 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp28_, "$updated_at", _tmp30_);
#line 1253 "../core/Services/Database.vala"
	_tmp31_ = stmt;
#line 1253 "../core/Services/Database.vala"
	_tmp32_ = objects_item_get_section_id (item);
#line 1253 "../core/Services/Database.vala"
	_tmp33_ = _tmp32_;
#line 1253 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp31_, "$section_id", _tmp33_);
#line 1254 "../core/Services/Database.vala"
	_tmp34_ = stmt;
#line 1254 "../core/Services/Database.vala"
	_tmp35_ = objects_item_get_project_id (item);
#line 1254 "../core/Services/Database.vala"
	_tmp36_ = _tmp35_;
#line 1254 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp34_, "$project_id", _tmp36_);
#line 1255 "../core/Services/Database.vala"
	_tmp37_ = stmt;
#line 1255 "../core/Services/Database.vala"
	_tmp38_ = objects_item_get_parent_id (item);
#line 1255 "../core/Services/Database.vala"
	_tmp39_ = _tmp38_;
#line 1255 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp37_, "$parent_id", _tmp39_);
#line 1256 "../core/Services/Database.vala"
	_tmp40_ = stmt;
#line 1256 "../core/Services/Database.vala"
	_tmp41_ = objects_item_get_priority (item);
#line 1256 "../core/Services/Database.vala"
	_tmp42_ = _tmp41_;
#line 1256 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp40_, "$priority", _tmp42_);
#line 1257 "../core/Services/Database.vala"
	_tmp43_ = stmt;
#line 1257 "../core/Services/Database.vala"
	_tmp44_ = objects_item_get_child_order (item);
#line 1257 "../core/Services/Database.vala"
	_tmp45_ = _tmp44_;
#line 1257 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp43_, "$child_order", _tmp45_);
#line 1258 "../core/Services/Database.vala"
	_tmp46_ = stmt;
#line 1258 "../core/Services/Database.vala"
	_tmp47_ = objects_item_get_checked (item);
#line 1258 "../core/Services/Database.vala"
	_tmp48_ = _tmp47_;
#line 1258 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp46_, "$checked", _tmp48_);
#line 1259 "../core/Services/Database.vala"
	_tmp49_ = stmt;
#line 1259 "../core/Services/Database.vala"
	_tmp50_ = objects_item_get_is_deleted (item);
#line 1259 "../core/Services/Database.vala"
	_tmp51_ = _tmp50_;
#line 1259 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp49_, "$is_deleted", _tmp51_);
#line 1260 "../core/Services/Database.vala"
	_tmp52_ = stmt;
#line 1260 "../core/Services/Database.vala"
	_tmp53_ = objects_item_get_day_order (item);
#line 1260 "../core/Services/Database.vala"
	_tmp54_ = _tmp53_;
#line 1260 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp52_, "$day_order", _tmp54_);
#line 1261 "../core/Services/Database.vala"
	_tmp55_ = stmt;
#line 1261 "../core/Services/Database.vala"
	_tmp56_ = objects_item_get_collapsed (item);
#line 1261 "../core/Services/Database.vala"
	_tmp57_ = _tmp56_;
#line 1261 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp55_, "$collapsed", _tmp57_);
#line 1262 "../core/Services/Database.vala"
	_tmp58_ = stmt;
#line 1262 "../core/Services/Database.vala"
	_tmp59_ = objects_item_get_pinned (item);
#line 1262 "../core/Services/Database.vala"
	_tmp60_ = _tmp59_;
#line 1262 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp58_, "$pinned", _tmp60_);
#line 1263 "../core/Services/Database.vala"
	_tmp61_ = stmt;
#line 1263 "../core/Services/Database.vala"
	_tmp62_ = objects_item_get_labels (item);
#line 1263 "../core/Services/Database.vala"
	_tmp63_ = _tmp62_;
#line 1263 "../core/Services/Database.vala"
	_tmp64_ = services_database_get_labels_ids (self, _tmp63_);
#line 1263 "../core/Services/Database.vala"
	_tmp65_ = _tmp64_;
#line 1263 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp61_, "$labels", _tmp65_);
#line 1263 "../core/Services/Database.vala"
	_g_free0 (_tmp65_);
#line 1264 "../core/Services/Database.vala"
	_tmp66_ = stmt;
#line 1264 "../core/Services/Database.vala"
	_tmp67_ = objects_item_get_extra_data (item);
#line 1264 "../core/Services/Database.vala"
	_tmp68_ = _tmp67_;
#line 1264 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp66_, "$extra_data", _tmp68_);
#line 1265 "../core/Services/Database.vala"
	_tmp69_ = stmt;
#line 1265 "../core/Services/Database.vala"
	_tmp70_ = objects_item_get_item_type (item);
#line 1265 "../core/Services/Database.vala"
	_tmp71_ = _tmp70_;
#line 1265 "../core/Services/Database.vala"
	_tmp72_ = item_type_to_string (_tmp71_);
#line 1265 "../core/Services/Database.vala"
	_tmp73_ = _tmp72_;
#line 1265 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp69_, "$item_type", _tmp73_);
#line 1265 "../core/Services/Database.vala"
	_g_free0 (_tmp73_);
#line 1266 "../core/Services/Database.vala"
	_tmp74_ = stmt;
#line 1266 "../core/Services/Database.vala"
	_tmp75_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1266 "../core/Services/Database.vala"
	_tmp76_ = _tmp75_;
#line 1266 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp74_, "$id", _tmp76_);
#line 1268 "../core/Services/Database.vala"
	_tmp77_ = stmt;
#line 1268 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp77_) != SQLITE_DONE) {
#line 5306 "Database.c"
		sqlite3* _tmp78_;
		sqlite3* _tmp79_;
		const gchar* _tmp80_;
#line 1269 "../core/Services/Database.vala"
		_tmp78_ = self->priv->db;
#line 1269 "../core/Services/Database.vala"
		_tmp79_ = self->priv->db;
#line 1269 "../core/Services/Database.vala"
		_tmp80_ = sqlite3_errmsg (_tmp79_);
#line 1269 "../core/Services/Database.vala"
		g_warning ("Database.vala:1269: Error: %d: %s", sqlite3_errcode (_tmp78_), _tmp80_);
#line 5318 "Database.c"
	}
#line 1273 "../core/Services/Database.vala"
	_tmp81_ = stmt;
#line 1273 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp81_) == SQLITE_DONE;
#line 1273 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1273 "../core/Services/Database.vala"
	return result;
#line 5328 "Database.c"
}

gboolean
services_database_move_item (ServicesDatabase* self,
                             ObjectsItem* item)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	sqlite3_stmt* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	sqlite3_stmt* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	sqlite3_stmt* _tmp27_;
	gboolean result;
#line 1276 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1276 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1277 "../core/Services/Database.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 1277 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1277 "../core/Services/Database.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 1277 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1277 "../core/Services/Database.vala"
	objects_item_set_updated_at (item, _tmp3_);
#line 1277 "../core/Services/Database.vala"
	_g_free0 (_tmp3_);
#line 1277 "../core/Services/Database.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1280 "../core/Services/Database.vala"
	_tmp4_ = g_strdup ("\n" \
"            UPDATE Items SET\n" \
"                section_id=$section_id,\n" \
"                project_id=$project_id,\n" \
"                parent_id=$parent_id\n" \
"            WHERE id=$id;\n" \
"        ");
#line 1280 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1280 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1288 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1288 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1288 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1288 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1288 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1288 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1288 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1288 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1289 "../core/Services/Database.vala"
	_tmp11_ = stmt;
#line 1289 "../core/Services/Database.vala"
	_tmp12_ = objects_item_get_section_id (item);
#line 1289 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1289 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp11_, "$section_id", _tmp13_);
#line 1290 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1290 "../core/Services/Database.vala"
	_tmp15_ = objects_item_get_project_id (item);
#line 1290 "../core/Services/Database.vala"
	_tmp16_ = _tmp15_;
#line 1290 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp14_, "$project_id", _tmp16_);
#line 1291 "../core/Services/Database.vala"
	_tmp17_ = stmt;
#line 1291 "../core/Services/Database.vala"
	_tmp18_ = objects_item_get_parent_id (item);
#line 1291 "../core/Services/Database.vala"
	_tmp19_ = _tmp18_;
#line 1291 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp17_, "$parent_id", _tmp19_);
#line 1292 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 1292 "../core/Services/Database.vala"
	_tmp21_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1292 "../core/Services/Database.vala"
	_tmp22_ = _tmp21_;
#line 1292 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp20_, "$id", _tmp22_);
#line 1294 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1294 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp23_) != SQLITE_DONE) {
#line 5438 "Database.c"
		sqlite3* _tmp24_;
		sqlite3* _tmp25_;
		const gchar* _tmp26_;
#line 1295 "../core/Services/Database.vala"
		_tmp24_ = self->priv->db;
#line 1295 "../core/Services/Database.vala"
		_tmp25_ = self->priv->db;
#line 1295 "../core/Services/Database.vala"
		_tmp26_ = sqlite3_errmsg (_tmp25_);
#line 1295 "../core/Services/Database.vala"
		g_warning ("Database.vala:1295: Error: %d: %s", sqlite3_errcode (_tmp24_), _tmp26_);
#line 5450 "Database.c"
	}
#line 1299 "../core/Services/Database.vala"
	_tmp27_ = stmt;
#line 1299 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp27_) == SQLITE_DONE;
#line 1299 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1299 "../core/Services/Database.vala"
	return result;
#line 5460 "Database.c"
}

gboolean
services_database_complete_item (ServicesDatabase* self,
                                 ObjectsItem* item,
                                 gboolean old_checked)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp20_;
	gboolean result;
#line 1302 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1302 "../core/Services/Database.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1305 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET checked=$checked, completed_at=$completed" \
"_at\n" \
"            WHERE id=$id OR parent_id=$id;\n" \
"        ");
#line 1305 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1305 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1310 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1310 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1310 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1310 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1310 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1310 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1310 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1310 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1311 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1311 "../core/Services/Database.vala"
	_tmp8_ = objects_item_get_checked (item);
#line 1311 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1311 "../core/Services/Database.vala"
	services_database_set_parameter_bool (self, _tmp7_, "$checked", _tmp9_);
#line 1312 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1312 "../core/Services/Database.vala"
	_tmp11_ = objects_item_get_completed_at (item);
#line 1312 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1312 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$completed_at", _tmp12_);
#line 1313 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1313 "../core/Services/Database.vala"
	_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
#line 1313 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1313 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$id", _tmp15_);
#line 1315 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1315 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp16_) != SQLITE_DONE) {
#line 5542 "Database.c"
		sqlite3* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 1316 "../core/Services/Database.vala"
		_tmp17_ = self->priv->db;
#line 1316 "../core/Services/Database.vala"
		_tmp18_ = self->priv->db;
#line 1316 "../core/Services/Database.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 1316 "../core/Services/Database.vala"
		g_warning ("Database.vala:1316: Error: %d: %s", sqlite3_errcode (_tmp17_), _tmp19_);
#line 5554 "Database.c"
	}
#line 1320 "../core/Services/Database.vala"
	_tmp20_ = stmt;
#line 1320 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp20_) == SQLITE_DONE;
#line 1320 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1320 "../core/Services/Database.vala"
	return result;
#line 5564 "Database.c"
}

void
services_database_update_child_order (ServicesDatabase* self,
                                      ObjectsBaseObject* base_object)
{
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	sqlite3_stmt* _tmp26_;
#line 1323 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1323 "../core/Services/Database.vala"
	g_return_if_fail (base_object != NULL);
#line 1326 "../core/Services/Database.vala"
	_tmp0_ = objects_base_object_get_table_name (base_object);
#line 1326 "../core/Services/Database.vala"
	_tmp1_ = _tmp0_;
#line 1326 "../core/Services/Database.vala"
	_tmp2_ = objects_base_object_get_column_order_name (base_object);
#line 1326 "../core/Services/Database.vala"
	_tmp3_ = _tmp2_;
#line 1326 "../core/Services/Database.vala"
	_tmp4_ = g_strdup_printf ("\n            UPDATE %s SET %s=$order WHERE id=$id;\n        ", _tmp1_, _tmp3_);
#line 1326 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1326 "../core/Services/Database.vala"
	self->priv->sql = _tmp4_;
#line 1330 "../core/Services/Database.vala"
	_tmp5_ = self->priv->db;
#line 1330 "../core/Services/Database.vala"
	_tmp6_ = self->priv->sql;
#line 1330 "../core/Services/Database.vala"
	_tmp7_ = self->priv->sql;
#line 1330 "../core/Services/Database.vala"
	_tmp8_ = strlen (_tmp7_);
#line 1330 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1330 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp5_, _tmp6_, _tmp9_, &_tmp10_, NULL);
#line 1330 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1330 "../core/Services/Database.vala"
	stmt = _tmp10_;
#line 1332 "../core/Services/Database.vala"
	if (OBJECTS_IS_ITEM (base_object)) {
#line 5623 "Database.c"
		sqlite3_stmt* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 1333 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1333 "../core/Services/Database.vala"
		_tmp12_ = objects_item_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_ITEM, ObjectsItem));
#line 1333 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1333 "../core/Services/Database.vala"
		services_database_set_parameter_int (self, _tmp11_, "$order", _tmp13_);
#line 5635 "Database.c"
	} else {
#line 1334 "../core/Services/Database.vala"
		if (OBJECTS_IS_SECTION (base_object)) {
#line 5639 "Database.c"
			sqlite3_stmt* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 1335 "../core/Services/Database.vala"
			_tmp14_ = stmt;
#line 1335 "../core/Services/Database.vala"
			_tmp15_ = objects_section_get_section_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_SECTION, ObjectsSection));
#line 1335 "../core/Services/Database.vala"
			_tmp16_ = _tmp15_;
#line 1335 "../core/Services/Database.vala"
			services_database_set_parameter_int (self, _tmp14_, "$order", _tmp16_);
#line 5651 "Database.c"
		} else {
#line 1336 "../core/Services/Database.vala"
			if (OBJECTS_IS_PROJECT (base_object)) {
#line 5655 "Database.c"
				sqlite3_stmt* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 1337 "../core/Services/Database.vala"
				_tmp17_ = stmt;
#line 1337 "../core/Services/Database.vala"
				_tmp18_ = objects_project_get_child_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_PROJECT, ObjectsProject));
#line 1337 "../core/Services/Database.vala"
				_tmp19_ = _tmp18_;
#line 1337 "../core/Services/Database.vala"
				services_database_set_parameter_int (self, _tmp17_, "$order", _tmp19_);
#line 5667 "Database.c"
			} else {
#line 1338 "../core/Services/Database.vala"
				if (OBJECTS_IS_LABEL (base_object)) {
#line 5671 "Database.c"
					sqlite3_stmt* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 1339 "../core/Services/Database.vala"
					_tmp20_ = stmt;
#line 1339 "../core/Services/Database.vala"
					_tmp21_ = objects_label_get_item_order (G_TYPE_CHECK_INSTANCE_CAST (base_object, OBJECTS_TYPE_LABEL, ObjectsLabel));
#line 1339 "../core/Services/Database.vala"
					_tmp22_ = _tmp21_;
#line 1339 "../core/Services/Database.vala"
					services_database_set_parameter_int (self, _tmp20_, "$order", _tmp22_);
#line 5683 "Database.c"
				}
			}
		}
	}
#line 1342 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1342 "../core/Services/Database.vala"
	_tmp24_ = objects_base_object_get_id (base_object);
#line 1342 "../core/Services/Database.vala"
	_tmp25_ = _tmp24_;
#line 1342 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp23_, "$id", _tmp25_);
#line 1344 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1344 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp26_) != SQLITE_DONE) {
#line 5700 "Database.c"
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 1345 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1345 "../core/Services/Database.vala"
		_tmp28_ = self->priv->db;
#line 1345 "../core/Services/Database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 1345 "../core/Services/Database.vala"
		g_warning ("Database.vala:1345: Error: %d: %s", sqlite3_errcode (_tmp27_), _tmp29_);
#line 5712 "Database.c"
	}
#line 1323 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 5716 "Database.c"
}

gboolean
services_database_insert_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	ReminderType _tmp14_;
	ReminderType _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	ObjectsDueDate* _tmp19_;
	ObjectsDueDate* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	sqlite3_stmt* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp30_;
	gboolean result;
#line 1352 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1352 "../core/Services/Database.vala"
	g_return_val_if_fail (reminder != NULL, FALSE);
#line 1356 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Reminders (id, item_id, type, due, m" \
"m_offset)\n" \
"            VALUES ($id, $item_id, $type, $due, $mm_offset);\n" \
"        ");
#line 1356 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1356 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1361 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1361 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1361 "../core/Services/Database.vala"
	_tmp3_ = sql;
#line 1361 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1361 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1361 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1361 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1361 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1362 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1362 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1362 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1362 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1363 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1363 "../core/Services/Database.vala"
	_tmp11_ = objects_reminder_get_item_id (reminder);
#line 1363 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1363 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$item_id", _tmp12_);
#line 1364 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1364 "../core/Services/Database.vala"
	_tmp14_ = objects_reminder_get_reminder_type (reminder);
#line 1364 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1364 "../core/Services/Database.vala"
	_tmp16_ = reminder_type_to_string (_tmp15_);
#line 1364 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1364 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$type", _tmp17_);
#line 1364 "../core/Services/Database.vala"
	_g_free0 (_tmp17_);
#line 1365 "../core/Services/Database.vala"
	_tmp18_ = stmt;
#line 1365 "../core/Services/Database.vala"
	_tmp19_ = objects_reminder_get_due (reminder);
#line 1365 "../core/Services/Database.vala"
	_tmp20_ = _tmp19_;
#line 1365 "../core/Services/Database.vala"
	_tmp21_ = objects_due_date_to_string (_tmp20_);
#line 1365 "../core/Services/Database.vala"
	_tmp22_ = _tmp21_;
#line 1365 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp18_, "$due", _tmp22_);
#line 1365 "../core/Services/Database.vala"
	_g_free0 (_tmp22_);
#line 1366 "../core/Services/Database.vala"
	_tmp23_ = stmt;
#line 1366 "../core/Services/Database.vala"
	_tmp24_ = objects_reminder_get_mm_offset (reminder);
#line 1366 "../core/Services/Database.vala"
	_tmp25_ = _tmp24_;
#line 1366 "../core/Services/Database.vala"
	services_database_set_parameter_int (self, _tmp23_, "$mm_offset", _tmp25_);
#line 1368 "../core/Services/Database.vala"
	_tmp26_ = stmt;
#line 1368 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp26_) != SQLITE_DONE) {
#line 5836 "Database.c"
		sqlite3* _tmp27_;
		sqlite3* _tmp28_;
		const gchar* _tmp29_;
#line 1369 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1369 "../core/Services/Database.vala"
		_tmp28_ = self->priv->db;
#line 1369 "../core/Services/Database.vala"
		_tmp29_ = sqlite3_errmsg (_tmp28_);
#line 1369 "../core/Services/Database.vala"
		g_warning ("Database.vala:1369: Error: %d: %s", sqlite3_errcode (_tmp27_), _tmp29_);
#line 5848 "Database.c"
	}
#line 1373 "../core/Services/Database.vala"
	_tmp30_ = stmt;
#line 1373 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp30_) == SQLITE_DONE;
#line 1373 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1373 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1373 "../core/Services/Database.vala"
	return result;
#line 5860 "Database.c"
}

GeeArrayList*
services_database_get_reminders_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1376 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1377 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1377 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1380 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT id, item_id, type, due, mm_offset FROM Reminders;\n" \
"        ");
#line 1380 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1380 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1384 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1384 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1384 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1384 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1384 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1384 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1384 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1384 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1386 "../core/Services/Database.vala"
	while (TRUE) {
#line 5907 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsReminder* _tmp11_;
		ObjectsReminder* _tmp12_;
#line 1386 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1386 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1386 "../core/Services/Database.vala"
			break;
#line 5919 "Database.c"
		}
#line 1387 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1387 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1387 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_reminder (self, _tmp10_);
#line 1387 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1387 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1387 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 5933 "Database.c"
	}
#line 1390 "../core/Services/Database.vala"
	result = return_value;
#line 1390 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1390 "../core/Services/Database.vala"
	return result;
#line 5941 "Database.c"
}

ObjectsReminder*
_services_database_fill_reminder (ServicesDatabase* self,
                                  sqlite3_stmt* stmt)
{
	ObjectsReminder* return_value = NULL;
	ObjectsReminder* _tmp0_;
	ObjectsReminder* _tmp1_;
	const gchar* _tmp2_;
	ObjectsReminder* _tmp3_;
	const gchar* _tmp4_;
	ReminderType _tmp5_ = 0;
	const gchar* _tmp6_;
	ObjectsReminder* _tmp7_;
	ObjectsReminder* _tmp8_;
	ObjectsDueDate* _tmp9_;
	ObjectsDueDate* _tmp10_;
	const gchar* _tmp11_;
	JsonObject* _tmp12_;
	JsonObject* _tmp13_;
	ObjectsReminder* _tmp14_;
	ObjectsReminder* result;
#line 1393 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1393 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1394 "../core/Services/Database.vala"
	_tmp0_ = objects_reminder_new ();
#line 1394 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1395 "../core/Services/Database.vala"
	_tmp1_ = return_value;
#line 1395 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1395 "../core/Services/Database.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp1_, _tmp2_);
#line 1396 "../core/Services/Database.vala"
	_tmp3_ = return_value;
#line 1396 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1396 "../core/Services/Database.vala"
	objects_reminder_set_item_id (_tmp3_, _tmp4_);
#line 1397 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1397 "../core/Services/Database.vala"
	if (g_strcmp0 (_tmp6_, "absolute") == 0) {
#line 1397 "../core/Services/Database.vala"
		_tmp5_ = REMINDER_TYPE_ABSOLUTE;
#line 5991 "Database.c"
	} else {
#line 1397 "../core/Services/Database.vala"
		_tmp5_ = REMINDER_TYPE_RELATIVE;
#line 5995 "Database.c"
	}
#line 1397 "../core/Services/Database.vala"
	_tmp7_ = return_value;
#line 1397 "../core/Services/Database.vala"
	objects_reminder_set_reminder_type (_tmp7_, _tmp5_);
#line 1398 "../core/Services/Database.vala"
	_tmp8_ = return_value;
#line 1398 "../core/Services/Database.vala"
	_tmp9_ = objects_reminder_get_due (_tmp8_);
#line 1398 "../core/Services/Database.vala"
	_tmp10_ = _tmp9_;
#line 1398 "../core/Services/Database.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1398 "../core/Services/Database.vala"
	_tmp12_ = services_database_get_due_parameter (self, _tmp11_);
#line 1398 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 1398 "../core/Services/Database.vala"
	objects_due_date_update_from_json (_tmp10_, _tmp13_);
#line 1398 "../core/Services/Database.vala"
	_json_object_unref0 (_tmp13_);
#line 1399 "../core/Services/Database.vala"
	_tmp14_ = return_value;
#line 1399 "../core/Services/Database.vala"
	objects_reminder_set_mm_offset (_tmp14_, sqlite3_column_int (stmt, 4));
#line 1400 "../core/Services/Database.vala"
	result = return_value;
#line 1400 "../core/Services/Database.vala"
	return result;
#line 6025 "Database.c"
}

GeeArrayList*
services_database_get_reminders_by_item_id (ServicesDatabase* self,
                                            const gchar* id)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* result;
#line 1403 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1403 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1404 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1404 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1407 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT id, item_id, type, due, mm_offset FROM Reminders WH" \
"ERE item_id=$item_id;\n" \
"        ");
#line 1407 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1407 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1411 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1411 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1411 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1411 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1411 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1411 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1411 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1411 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1412 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1412 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$item_id", id);
#line 1414 "../core/Services/Database.vala"
	while (TRUE) {
#line 6080 "Database.c"
		sqlite3_stmt* _tmp9_;
		GeeArrayList* _tmp10_;
		sqlite3_stmt* _tmp11_;
		ObjectsReminder* _tmp12_;
		ObjectsReminder* _tmp13_;
#line 1414 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1414 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp9_) == SQLITE_ROW)) {
#line 1414 "../core/Services/Database.vala"
			break;
#line 6092 "Database.c"
		}
#line 1415 "../core/Services/Database.vala"
		_tmp10_ = return_value;
#line 1415 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1415 "../core/Services/Database.vala"
		_tmp12_ = _services_database_fill_reminder (self, _tmp11_);
#line 1415 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1415 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
#line 1415 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp13_);
#line 6106 "Database.c"
	}
#line 1418 "../core/Services/Database.vala"
	result = return_value;
#line 1418 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1418 "../core/Services/Database.vala"
	return result;
#line 6114 "Database.c"
}

gboolean
services_database_delete_reminder (ServicesDatabase* self,
                                   ObjectsReminder* reminder)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1421 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1421 "../core/Services/Database.vala"
	g_return_val_if_fail (reminder != NULL, FALSE);
#line 1424 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Reminders WHERE id=$id;\n        ");
#line 1424 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1424 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1428 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1428 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1428 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1428 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1428 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1428 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1428 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1428 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1429 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1429 "../core/Services/Database.vala"
	_tmp8_ = objects_base_object_get_id ((ObjectsBaseObject*) reminder);
#line 1429 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1429 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1431 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1431 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 6173 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1432 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1432 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1432 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1432 "../core/Services/Database.vala"
		g_warning ("Database.vala:1432: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 6185 "Database.c"
	}
#line 1436 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1436 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1436 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1436 "../core/Services/Database.vala"
	return result;
#line 6195 "Database.c"
}

gboolean
services_database_insert_attachment (ServicesDatabase* self,
                                     ObjectsAttachment* attachment)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	gint64 _tmp20_;
	gint64 _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
	sqlite3_stmt* _tmp29_;
	gboolean result;
#line 1440 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1440 "../core/Services/Database.vala"
	g_return_val_if_fail (attachment != NULL, FALSE);
#line 1444 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Attachments (id, item_id, file_type," \
" file_name, file_size, file_path)\n" \
"            VALUES ($id, $item_id, $file_type, $file_name, $file_size," \
" $file_path);\n" \
"        ");
#line 1444 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1444 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1449 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1449 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1449 "../core/Services/Database.vala"
	_tmp3_ = sql;
#line 1449 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1449 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1449 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1449 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1449 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1450 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1450 "../core/Services/Database.vala"
	_tmp8_ = objects_attachment_get_id (attachment);
#line 1450 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1450 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1451 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1451 "../core/Services/Database.vala"
	_tmp11_ = objects_attachment_get_item_id (attachment);
#line 1451 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1451 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$item_id", _tmp12_);
#line 1452 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1452 "../core/Services/Database.vala"
	_tmp14_ = objects_attachment_get_file_type (attachment);
#line 1452 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1452 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$file_type", _tmp15_);
#line 1453 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1453 "../core/Services/Database.vala"
	_tmp17_ = objects_attachment_get_file_name (attachment);
#line 1453 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1453 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$file_name", _tmp18_);
#line 1454 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1454 "../core/Services/Database.vala"
	_tmp20_ = objects_attachment_get_file_size (attachment);
#line 1454 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1454 "../core/Services/Database.vala"
	services_database_set_parameter_int64 (self, _tmp19_, "$file_size", _tmp21_);
#line 1455 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1455 "../core/Services/Database.vala"
	_tmp23_ = objects_attachment_get_file_path (attachment);
#line 1455 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1455 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$file_path", _tmp24_);
#line 1457 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1457 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 6310 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1458 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1458 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1458 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1458 "../core/Services/Database.vala"
		g_warning ("Database.vala:1458: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 6322 "Database.c"
	}
#line 1462 "../core/Services/Database.vala"
	_tmp29_ = stmt;
#line 1462 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp29_) == SQLITE_DONE;
#line 1462 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1462 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1462 "../core/Services/Database.vala"
	return result;
#line 6334 "Database.c"
}

GeeArrayList*
services_database_get_attachments_collection (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1465 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1466 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1466 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1469 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Attachments;\n        ");
#line 1469 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1469 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1473 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1473 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1473 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1473 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1473 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1473 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1473 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1473 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1475 "../core/Services/Database.vala"
	while (TRUE) {
#line 6381 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsAttachment* _tmp11_;
		ObjectsAttachment* _tmp12_;
#line 1475 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1475 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1475 "../core/Services/Database.vala"
			break;
#line 6393 "Database.c"
		}
#line 1476 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1476 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1476 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_attachment (self, _tmp10_);
#line 1476 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1476 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1476 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 6407 "Database.c"
	}
#line 1479 "../core/Services/Database.vala"
	result = return_value;
#line 1479 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1479 "../core/Services/Database.vala"
	return result;
#line 6415 "Database.c"
}

ObjectsAttachment*
_services_database_fill_attachment (ServicesDatabase* self,
                                    sqlite3_stmt* stmt)
{
	ObjectsAttachment* return_value = NULL;
	ObjectsAttachment* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ObjectsAttachment* result;
#line 1482 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1482 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1483 "../core/Services/Database.vala"
	_tmp0_ = objects_attachment_new ();
#line 1483 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1484 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1484 "../core/Services/Database.vala"
	objects_attachment_set_id (return_value, _tmp1_);
#line 1485 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1485 "../core/Services/Database.vala"
	objects_attachment_set_item_id (return_value, _tmp2_);
#line 1486 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1486 "../core/Services/Database.vala"
	objects_attachment_set_file_type (return_value, _tmp3_);
#line 1487 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1487 "../core/Services/Database.vala"
	objects_attachment_set_file_name (return_value, _tmp4_);
#line 1488 "../core/Services/Database.vala"
	objects_attachment_set_file_size (return_value, sqlite3_column_int64 (stmt, 4));
#line 1489 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1489 "../core/Services/Database.vala"
	objects_attachment_set_file_path (return_value, _tmp5_);
#line 1490 "../core/Services/Database.vala"
	result = return_value;
#line 1490 "../core/Services/Database.vala"
	return result;
#line 6464 "Database.c"
}

gboolean
services_database_delete_attachment (ServicesDatabase* self,
                                     ObjectsAttachment* attachment)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp14_;
	gboolean result;
#line 1493 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1493 "../core/Services/Database.vala"
	g_return_val_if_fail (attachment != NULL, FALSE);
#line 1496 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Attachments WHERE id=$id;\n        ");
#line 1496 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1496 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1500 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1500 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1500 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1500 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1500 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1500 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1500 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1500 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1501 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1501 "../core/Services/Database.vala"
	_tmp8_ = objects_attachment_get_id (attachment);
#line 1501 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1501 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", _tmp9_);
#line 1503 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1503 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 6523 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1504 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1504 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1504 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1504 "../core/Services/Database.vala"
		g_warning ("Database.vala:1504: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 6535 "Database.c"
	}
#line 1508 "../core/Services/Database.vala"
	_tmp14_ = stmt;
#line 1508 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp14_) == SQLITE_DONE;
#line 1508 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1508 "../core/Services/Database.vala"
	return result;
#line 6545 "Database.c"
}

void
services_database_insert_queue (ServicesDatabase* self,
                                ObjectsQueue* queue)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	sqlite3_stmt* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_;
#line 1515 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1515 "../core/Services/Database.vala"
	g_return_if_fail (queue != NULL);
#line 1518 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO Queue (uuid, object_id, query, temp_" \
"id, args, date_added)\n" \
"            VALUES ($uuid, $object_id, $query, $temp_id, $args, $date_" \
"added);\n" \
"        ");
#line 1518 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1518 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1523 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1523 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1523 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1523 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1523 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1523 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1523 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1523 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1524 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1524 "../core/Services/Database.vala"
	_tmp8_ = objects_queue_get_uuid (queue);
#line 1524 "../core/Services/Database.vala"
	_tmp9_ = _tmp8_;
#line 1524 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", _tmp9_);
#line 1525 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1525 "../core/Services/Database.vala"
	_tmp11_ = objects_queue_get_object_id (queue);
#line 1525 "../core/Services/Database.vala"
	_tmp12_ = _tmp11_;
#line 1525 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp10_, "$object_id", _tmp12_);
#line 1526 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1526 "../core/Services/Database.vala"
	_tmp14_ = objects_queue_get_query (queue);
#line 1526 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 1526 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp13_, "$query", _tmp15_);
#line 1527 "../core/Services/Database.vala"
	_tmp16_ = stmt;
#line 1527 "../core/Services/Database.vala"
	_tmp17_ = objects_queue_get_temp_id (queue);
#line 1527 "../core/Services/Database.vala"
	_tmp18_ = _tmp17_;
#line 1527 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp16_, "$temp_id", _tmp18_);
#line 1528 "../core/Services/Database.vala"
	_tmp19_ = stmt;
#line 1528 "../core/Services/Database.vala"
	_tmp20_ = objects_queue_get_args (queue);
#line 1528 "../core/Services/Database.vala"
	_tmp21_ = _tmp20_;
#line 1528 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp19_, "$args", _tmp21_);
#line 1529 "../core/Services/Database.vala"
	_tmp22_ = stmt;
#line 1529 "../core/Services/Database.vala"
	_tmp23_ = objects_queue_get_date_added (queue);
#line 1529 "../core/Services/Database.vala"
	_tmp24_ = _tmp23_;
#line 1529 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp22_, "$date_added", _tmp24_);
#line 1531 "../core/Services/Database.vala"
	_tmp25_ = stmt;
#line 1531 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp25_) != SQLITE_DONE) {
#line 6657 "Database.c"
		sqlite3* _tmp26_;
		sqlite3* _tmp27_;
		const gchar* _tmp28_;
#line 1532 "../core/Services/Database.vala"
		_tmp26_ = self->priv->db;
#line 1532 "../core/Services/Database.vala"
		_tmp27_ = self->priv->db;
#line 1532 "../core/Services/Database.vala"
		_tmp28_ = sqlite3_errmsg (_tmp27_);
#line 1532 "../core/Services/Database.vala"
		g_warning ("Database.vala:1532: Error: %d: %s", sqlite3_errcode (_tmp26_), _tmp28_);
#line 6669 "Database.c"
	}
#line 1515 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 6673 "Database.c"
}

GeeArrayList*
services_database_get_all_queue (ServicesDatabase* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	GeeArrayList* result;
#line 1538 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1539 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_QUEUE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1539 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1542 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n            SELECT * FROM Queue ORDER BY date_added;\n        ");
#line 1542 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1542 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1546 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1546 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1546 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1546 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1546 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1546 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1546 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1546 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1548 "../core/Services/Database.vala"
	while (TRUE) {
#line 6720 "Database.c"
		sqlite3_stmt* _tmp8_;
		GeeArrayList* _tmp9_;
		sqlite3_stmt* _tmp10_;
		ObjectsQueue* _tmp11_;
		ObjectsQueue* _tmp12_;
#line 1548 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1548 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1548 "../core/Services/Database.vala"
			break;
#line 6732 "Database.c"
		}
#line 1549 "../core/Services/Database.vala"
		_tmp9_ = return_value;
#line 1549 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1549 "../core/Services/Database.vala"
		_tmp11_ = _services_database_fill_queue (self, _tmp10_);
#line 1549 "../core/Services/Database.vala"
		_tmp12_ = _tmp11_;
#line 1549 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 1549 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp12_);
#line 6746 "Database.c"
	}
#line 1552 "../core/Services/Database.vala"
	result = return_value;
#line 1552 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1552 "../core/Services/Database.vala"
	return result;
#line 6754 "Database.c"
}

ObjectsQueue*
_services_database_fill_queue (ServicesDatabase* self,
                               sqlite3_stmt* stmt)
{
	ObjectsQueue* return_value = NULL;
	ObjectsQueue* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	ObjectsQueue* result;
#line 1555 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1555 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1556 "../core/Services/Database.vala"
	_tmp0_ = objects_queue_new ();
#line 1556 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1557 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 0);
#line 1557 "../core/Services/Database.vala"
	objects_queue_set_uuid (return_value, _tmp1_);
#line 1558 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1558 "../core/Services/Database.vala"
	objects_queue_set_object_id (return_value, _tmp2_);
#line 1559 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1559 "../core/Services/Database.vala"
	objects_queue_set_query (return_value, _tmp3_);
#line 1560 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1560 "../core/Services/Database.vala"
	objects_queue_set_temp_id (return_value, _tmp4_);
#line 1561 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1561 "../core/Services/Database.vala"
	objects_queue_set_args (return_value, _tmp5_);
#line 1562 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1562 "../core/Services/Database.vala"
	objects_queue_set_date_added (return_value, _tmp6_);
#line 1563 "../core/Services/Database.vala"
	result = return_value;
#line 1563 "../core/Services/Database.vala"
	return result;
#line 6806 "Database.c"
}

void
services_database_insert_CurTempIds (ServicesDatabase* self,
                                     const gchar* id,
                                     const gchar* temp_id,
                                     const gchar* object)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
#line 1566 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1566 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 1566 "../core/Services/Database.vala"
	g_return_if_fail (temp_id != NULL);
#line 1566 "../core/Services/Database.vala"
	g_return_if_fail (object != NULL);
#line 1569 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            INSERT OR IGNORE INTO CurTempIds (id, temp_id, object)\n" \
"            VALUES ($id, $temp_id, $object);\n" \
"        ");
#line 1569 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1569 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1574 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1574 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1574 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1574 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1574 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1574 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1574 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1574 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1575 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1575 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1576 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1576 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$temp_id", temp_id);
#line 1577 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1577 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp9_, "$object", object);
#line 1579 "../core/Services/Database.vala"
	_tmp10_ = stmt;
#line 1579 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp10_) != SQLITE_DONE) {
#line 6873 "Database.c"
		sqlite3* _tmp11_;
		sqlite3* _tmp12_;
		const gchar* _tmp13_;
#line 1580 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1580 "../core/Services/Database.vala"
		_tmp12_ = self->priv->db;
#line 1580 "../core/Services/Database.vala"
		_tmp13_ = sqlite3_errmsg (_tmp12_);
#line 1580 "../core/Services/Database.vala"
		g_warning ("Database.vala:1580: Error: %d: %s", sqlite3_errcode (_tmp11_), _tmp13_);
#line 6885 "Database.c"
	}
#line 1566 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 6889 "Database.c"
}

gboolean
services_database_curTempIds_exists (ServicesDatabase* self,
                                     const gchar* id)
{
	gboolean returned = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gboolean result;
#line 1586 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1586 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 1587 "../core/Services/Database.vala"
	returned = FALSE;
#line 1590 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            SELECT COUNT (*) FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1590 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1590 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1594 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1594 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1594 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1594 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1594 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1594 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1594 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1594 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1595 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1595 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1597 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1597 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) == SQLITE_ROW) {
#line 6944 "Database.c"
		sqlite3_stmt* _tmp9_;
#line 1598 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1598 "../core/Services/Database.vala"
		returned = sqlite3_column_int (_tmp9_, 0) > 0;
#line 6950 "Database.c"
	}
#line 1602 "../core/Services/Database.vala"
	result = returned;
#line 1602 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1602 "../core/Services/Database.vala"
	return result;
#line 6958 "Database.c"
}

gchar*
services_database_get_temp_id (ServicesDatabase* self,
                               const gchar* id)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gchar* result;
#line 1605 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1605 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1606 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 1606 "../core/Services/Database.vala"
	returned = _tmp0_;
#line 1609 "../core/Services/Database.vala"
	_tmp1_ = g_strdup ("\n" \
"            SELECT temp_id FROM CurTempIds WHERE id = $id;\n" \
"        ");
#line 1609 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1609 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1613 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1613 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1613 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1613 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1613 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1613 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1613 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1613 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1614 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1614 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$id", id);
#line 1616 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1616 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) == SQLITE_ROW) {
#line 7016 "Database.c"
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1617 "../core/Services/Database.vala"
		_tmp10_ = stmt;
#line 1617 "../core/Services/Database.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 1617 "../core/Services/Database.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1617 "../core/Services/Database.vala"
		_g_free0 (returned);
#line 1617 "../core/Services/Database.vala"
		returned = _tmp12_;
#line 7030 "Database.c"
	}
#line 1621 "../core/Services/Database.vala"
	result = returned;
#line 1621 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1621 "../core/Services/Database.vala"
	return result;
#line 7038 "Database.c"
}

gboolean
services_database_update_project_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1624 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1624 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1624 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1627 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Projects SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1627 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1627 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1631 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1631 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1631 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1631 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1631 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1631 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1631 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1631 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1632 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1632 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1633 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1633 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1635 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1635 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7099 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1636 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1636 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1636 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1636 "../core/Services/Database.vala"
		g_warning ("Database.vala:1636: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7111 "Database.c"
	}
#line 1640 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1640 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1640 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1640 "../core/Services/Database.vala"
	return result;
#line 7121 "Database.c"
}

gboolean
services_database_update_project_section_id (ServicesDatabase* self,
                                             const gchar* current_id,
                                             const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1643 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1643 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1643 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1646 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"                UPDATE Sections SET project_id = $new_id WHERE project" \
"_id = $current_id;\n" \
"            ");
#line 1646 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1646 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1650 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1650 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1650 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1650 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1650 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1650 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1650 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1650 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1651 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1651 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1652 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1652 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1654 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1654 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7182 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1655 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1655 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1655 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1655 "../core/Services/Database.vala"
		g_warning ("Database.vala:1655: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7194 "Database.c"
	}
#line 1659 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1659 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1659 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1659 "../core/Services/Database.vala"
	return result;
#line 7204 "Database.c"
}

gboolean
services_database_update_project_item_id (ServicesDatabase* self,
                                          const gchar* current_id,
                                          const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1662 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1662 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1662 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1665 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET project_id = $new_id WHERE project_id = $" \
"current_id;\n" \
"        ");
#line 1665 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1665 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1669 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1669 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1669 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1669 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1669 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1669 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1669 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1669 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1670 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1670 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1671 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1671 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1673 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1673 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7265 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1674 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1674 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1674 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1674 "../core/Services/Database.vala"
		g_warning ("Database.vala:1674: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7277 "Database.c"
	}
#line 1678 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1678 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1678 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1678 "../core/Services/Database.vala"
	return result;
#line 7287 "Database.c"
}

gboolean
services_database_update_section_id (ServicesDatabase* self,
                                     const gchar* current_id,
                                     const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1681 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1681 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1681 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1684 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Sections SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1684 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1684 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1688 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1688 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1688 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1688 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1688 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1688 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1688 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1688 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1689 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1689 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1690 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1690 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1692 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1692 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7348 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1693 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1693 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1693 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1693 "../core/Services/Database.vala"
		g_warning ("Database.vala:1693: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7360 "Database.c"
	}
#line 1697 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1697 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1697 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1697 "../core/Services/Database.vala"
	return result;
#line 7370 "Database.c"
}

gboolean
services_database_update_section_item_id (ServicesDatabase* self,
                                          const gchar* current_id,
                                          const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1700 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1700 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1700 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1703 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET section_id = $new_id WHERE section_id = $" \
"current_id;\n" \
"        ");
#line 1703 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1703 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1707 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1707 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1707 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1707 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1707 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1707 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1707 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1707 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1708 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1708 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1709 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1709 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1711 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1711 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7431 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1712 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1712 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1712 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1712 "../core/Services/Database.vala"
		g_warning ("Database.vala:1712: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7443 "Database.c"
	}
#line 1716 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1716 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1716 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1716 "../core/Services/Database.vala"
	return result;
#line 7453 "Database.c"
}

gboolean
services_database_update_item_id (ServicesDatabase* self,
                                  const gchar* current_id,
                                  const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1719 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1719 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1719 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1722 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET id = $new_id WHERE id = $current_id;\n" \
"        ");
#line 1722 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1722 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1726 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1726 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1726 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1726 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1726 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1726 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1726 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1726 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1727 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1727 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1728 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1728 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1730 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1730 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7514 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1731 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1731 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1731 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1731 "../core/Services/Database.vala"
		g_warning ("Database.vala:1731: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7526 "Database.c"
	}
#line 1735 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1735 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1735 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1735 "../core/Services/Database.vala"
	return result;
#line 7536 "Database.c"
}

gboolean
services_database_update_item_child_id (ServicesDatabase* self,
                                        const gchar* current_id,
                                        const gchar* new_id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp13_;
	gboolean result;
#line 1738 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1738 "../core/Services/Database.vala"
	g_return_val_if_fail (current_id != NULL, FALSE);
#line 1738 "../core/Services/Database.vala"
	g_return_val_if_fail (new_id != NULL, FALSE);
#line 1741 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            UPDATE Items SET parent_id = $new_id WHERE parent_id = $cu" \
"rrent_id;\n" \
"        ");
#line 1741 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1741 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1745 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1745 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1745 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1745 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1745 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1745 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1745 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1745 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1746 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1746 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$new_id", new_id);
#line 1747 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1747 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$current_id", current_id);
#line 1749 "../core/Services/Database.vala"
	_tmp9_ = stmt;
#line 1749 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp9_) != SQLITE_DONE) {
#line 7597 "Database.c"
		sqlite3* _tmp10_;
		sqlite3* _tmp11_;
		const gchar* _tmp12_;
#line 1750 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1750 "../core/Services/Database.vala"
		_tmp11_ = self->priv->db;
#line 1750 "../core/Services/Database.vala"
		_tmp12_ = sqlite3_errmsg (_tmp11_);
#line 1750 "../core/Services/Database.vala"
		g_warning ("Database.vala:1750: Error: %d: %s", sqlite3_errcode (_tmp10_), _tmp12_);
#line 7609 "Database.c"
	}
#line 1754 "../core/Services/Database.vala"
	_tmp13_ = stmt;
#line 1754 "../core/Services/Database.vala"
	result = sqlite3_step (_tmp13_) == SQLITE_DONE;
#line 1754 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1754 "../core/Services/Database.vala"
	return result;
#line 7619 "Database.c"
}

void
services_database_remove_CurTempIds (ServicesDatabase* self,
                                     const gchar* id)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
#line 1757 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1757 "../core/Services/Database.vala"
	g_return_if_fail (id != NULL);
#line 1760 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds WHERE id = $id;\n        ");
#line 1760 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1760 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1764 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1764 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1764 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1764 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1764 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1764 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1764 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1764 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1765 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1765 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$id", id);
#line 1767 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1767 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 7670 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 1768 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1768 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1768 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 1768 "../core/Services/Database.vala"
		g_warning ("Database.vala:1768: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 7682 "Database.c"
	}
#line 1757 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7686 "Database.c"
}

void
services_database_remove_queue (ServicesDatabase* self,
                                const gchar* uuid)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
#line 1774 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1774 "../core/Services/Database.vala"
	g_return_if_fail (uuid != NULL);
#line 1777 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue WHERE uuid = $uuid;\n        ");
#line 1777 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1777 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1781 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1781 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1781 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1781 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1781 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1781 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1781 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1781 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1782 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1782 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp7_, "$uuid", uuid);
#line 1784 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1784 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_DONE) {
#line 7737 "Database.c"
		sqlite3* _tmp9_;
		sqlite3* _tmp10_;
		const gchar* _tmp11_;
#line 1785 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1785 "../core/Services/Database.vala"
		_tmp10_ = self->priv->db;
#line 1785 "../core/Services/Database.vala"
		_tmp11_ = sqlite3_errmsg (_tmp10_);
#line 1785 "../core/Services/Database.vala"
		g_warning ("Database.vala:1785: Error: %d: %s", sqlite3_errcode (_tmp9_), _tmp11_);
#line 7749 "Database.c"
	}
#line 1774 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7753 "Database.c"
}

void
services_database_clear_queue (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
#line 1791 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1796 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM Queue;\n        ");
#line 1796 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1796 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1800 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1800 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1800 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 1800 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1800 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 1800 "../core/Services/Database.vala"
	res = _tmp4_;
#line 1801 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1803 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 1803 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 7794 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 1804 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 1804 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 1804 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 1804 "../core/Services/Database.vala"
		g_warning ("Database.vala:1804: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 7806 "Database.c"
	}
#line 1791 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1791 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7812 "Database.c"
}

void
services_database_clear_cur_temp_ids (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* sql = NULL;
	gint res = 0;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
#line 1810 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1815 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n            DELETE FROM CurTempIds;\n        ");
#line 1815 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1815 "../core/Services/Database.vala"
	sql = _tmp0_;
#line 1819 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1819 "../core/Services/Database.vala"
	_tmp2_ = sql;
#line 1819 "../core/Services/Database.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp1_, _tmp2_, -1, &_tmp3_, NULL);
#line 1819 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1819 "../core/Services/Database.vala"
	stmt = _tmp3_;
#line 1819 "../core/Services/Database.vala"
	res = _tmp4_;
#line 1820 "../core/Services/Database.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1822 "../core/Services/Database.vala"
	_tmp5_ = stmt;
#line 1822 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_DONE) {
#line 7853 "Database.c"
		sqlite3* _tmp6_;
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 1823 "../core/Services/Database.vala"
		_tmp6_ = self->priv->db;
#line 1823 "../core/Services/Database.vala"
		_tmp7_ = self->priv->db;
#line 1823 "../core/Services/Database.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 1823 "../core/Services/Database.vala"
		g_warning ("Database.vala:1823: Error: %d: %s", sqlite3_errcode (_tmp6_), _tmp8_);
#line 7865 "Database.c"
	}
#line 1810 "../core/Services/Database.vala"
	_g_free0 (sql);
#line 1810 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 7871 "Database.c"
}

GeeArrayList*
services_database_get_events_by_item (ServicesDatabase* self,
                                      const gchar* id,
                                      gint start_week,
                                      gint end_week)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* result;
#line 1833 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1833 "../core/Services/Database.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1834 "../core/Services/Database.vala"
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_OBJECT_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1834 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1838 "../core/Services/Database.vala"
	_tmp1_ = g_strdup_printf ("\n" \
"            SELECT * FROM OEvents\n" \
"                WHERE object_id = $object_id\n" \
"                AND (event_date >= DATETIME('now', '-%d days')\n" \
"                AND event_date <= DATETIME('now', '-%d days'))\n" \
"            ORDER BY event_date DESC\n" \
"        ", end_week, start_week);
#line 1838 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1838 "../core/Services/Database.vala"
	self->priv->sql = _tmp1_;
#line 1846 "../core/Services/Database.vala"
	_tmp2_ = self->priv->db;
#line 1846 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1846 "../core/Services/Database.vala"
	_tmp4_ = self->priv->sql;
#line 1846 "../core/Services/Database.vala"
	_tmp5_ = strlen (_tmp4_);
#line 1846 "../core/Services/Database.vala"
	_tmp6_ = _tmp5_;
#line 1846 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 1846 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1846 "../core/Services/Database.vala"
	stmt = _tmp7_;
#line 1847 "../core/Services/Database.vala"
	_tmp8_ = stmt;
#line 1847 "../core/Services/Database.vala"
	services_database_set_parameter_str (self, _tmp8_, "$object_id", id);
#line 1849 "../core/Services/Database.vala"
	while (TRUE) {
#line 7928 "Database.c"
		sqlite3_stmt* _tmp9_;
		GeeArrayList* _tmp10_;
		sqlite3_stmt* _tmp11_;
		ObjectsObjectEvent* _tmp12_;
		ObjectsObjectEvent* _tmp13_;
#line 1849 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1849 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp9_) == SQLITE_ROW)) {
#line 1849 "../core/Services/Database.vala"
			break;
#line 7940 "Database.c"
		}
#line 1850 "../core/Services/Database.vala"
		_tmp10_ = return_value;
#line 1850 "../core/Services/Database.vala"
		_tmp11_ = stmt;
#line 1850 "../core/Services/Database.vala"
		_tmp12_ = _services_database_fill_object_event (self, _tmp11_);
#line 1850 "../core/Services/Database.vala"
		_tmp13_ = _tmp12_;
#line 1850 "../core/Services/Database.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
#line 1850 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp13_);
#line 7954 "Database.c"
	}
#line 1853 "../core/Services/Database.vala"
	result = return_value;
#line 1853 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1853 "../core/Services/Database.vala"
	return result;
#line 7962 "Database.c"
}

ObjectsObjectEvent*
_services_database_fill_object_event (ServicesDatabase* self,
                                      sqlite3_stmt* stmt)
{
	ObjectsObjectEvent* return_value = NULL;
	ObjectsObjectEvent* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	ObjectsObjectEvent* result;
#line 1856 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1856 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, NULL);
#line 1857 "../core/Services/Database.vala"
	_tmp0_ = objects_object_event_new ();
#line 1857 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 1858 "../core/Services/Database.vala"
	objects_object_event_set_id (return_value, sqlite3_column_int64 (stmt, 0));
#line 1859 "../core/Services/Database.vala"
	_tmp1_ = (const gchar*) sqlite3_column_text (stmt, 1);
#line 1859 "../core/Services/Database.vala"
	objects_object_event_set_event_type (return_value, object_event_type_parse (_tmp1_));
#line 1860 "../core/Services/Database.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (stmt, 2);
#line 1860 "../core/Services/Database.vala"
	objects_object_event_set_event_date (return_value, _tmp2_);
#line 1861 "../core/Services/Database.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (stmt, 3);
#line 1861 "../core/Services/Database.vala"
	objects_object_event_set_object_id (return_value, _tmp3_);
#line 1862 "../core/Services/Database.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (stmt, 4);
#line 1862 "../core/Services/Database.vala"
	objects_object_event_set_object_type (return_value, _tmp4_);
#line 1863 "../core/Services/Database.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (stmt, 5);
#line 1863 "../core/Services/Database.vala"
	objects_object_event_set_object_key (return_value, object_event_key_type_parse (_tmp5_));
#line 1864 "../core/Services/Database.vala"
	_tmp6_ = (const gchar*) sqlite3_column_text (stmt, 6);
#line 1864 "../core/Services/Database.vala"
	objects_object_event_set_object_old_value (return_value, _tmp6_);
#line 1865 "../core/Services/Database.vala"
	_tmp7_ = (const gchar*) sqlite3_column_text (stmt, 7);
#line 1865 "../core/Services/Database.vala"
	objects_object_event_set_object_new_value (return_value, _tmp7_);
#line 1866 "../core/Services/Database.vala"
	_tmp8_ = (const gchar*) sqlite3_column_text (stmt, 8);
#line 1866 "../core/Services/Database.vala"
	objects_object_event_set_parent_item_id (return_value, _tmp8_);
#line 1867 "../core/Services/Database.vala"
	_tmp9_ = (const gchar*) sqlite3_column_text (stmt, 9);
#line 1867 "../core/Services/Database.vala"
	objects_object_event_set_parent_project_id (return_value, _tmp9_);
#line 1868 "../core/Services/Database.vala"
	result = return_value;
#line 1868 "../core/Services/Database.vala"
	return result;
#line 8031 "Database.c"
}

static void
services_database_set_parameter_int (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     gint val)
{
	gint par_position = 0;
#line 1872 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1872 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 1873 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 1874 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, val);
#line 8049 "Database.c"
}

static void
services_database_set_parameter_int64 (ServicesDatabase* self,
                                       sqlite3_stmt* stmt,
                                       const gchar* par,
                                       gint64 val)
{
	gint par_position = 0;
#line 1877 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1877 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 1878 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 1879 "../core/Services/Database.vala"
	sqlite3_bind_int64 (stmt, par_position, val);
#line 8067 "Database.c"
}

static void
services_database_set_parameter_str (ServicesDatabase* self,
                                     sqlite3_stmt* stmt,
                                     const gchar* par,
                                     const gchar* val)
{
	gint par_position = 0;
	gchar* _tmp0_;
	GDestroyNotify _tmp1_;
#line 1882 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1882 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 1882 "../core/Services/Database.vala"
	g_return_if_fail (val != NULL);
#line 1883 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 1884 "../core/Services/Database.vala"
	_tmp0_ = g_strdup (val);
#line 1884 "../core/Services/Database.vala"
	_tmp1_ = g_free;
#line 1884 "../core/Services/Database.vala"
	sqlite3_bind_text (stmt, par_position, _tmp0_, -1, _tmp1_);
#line 8093 "Database.c"
}

static void
services_database_set_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      const gchar* par,
                                      gboolean val)
{
	gint par_position = 0;
	gint _tmp0_ = 0;
#line 1887 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1887 "../core/Services/Database.vala"
	g_return_if_fail (par != NULL);
#line 1888 "../core/Services/Database.vala"
	par_position = sqlite3_bind_parameter_index (stmt, par);
#line 1889 "../core/Services/Database.vala"
	if (val) {
#line 1889 "../core/Services/Database.vala"
		_tmp0_ = 1;
#line 8114 "Database.c"
	} else {
#line 1889 "../core/Services/Database.vala"
		_tmp0_ = 0;
#line 8118 "Database.c"
	}
#line 1889 "../core/Services/Database.vala"
	sqlite3_bind_int (stmt, par_position, _tmp0_);
#line 8122 "Database.c"
}

static gboolean
services_database_get_parameter_bool (ServicesDatabase* self,
                                      sqlite3_stmt* stmt,
                                      gint col)
{
	gboolean result;
#line 1892 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1892 "../core/Services/Database.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 1893 "../core/Services/Database.vala"
	result = sqlite3_column_int (stmt, col) == 1;
#line 1893 "../core/Services/Database.vala"
	return result;
#line 8139 "Database.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 1908 "../core/Services/Database.vala"
	return self ? json_object_ref (self) : NULL;
#line 8147 "Database.c"
}

JsonObject*
services_database_get_due_parameter (ServicesDatabase* self,
                                     const gchar* data)
{
	JsonParser* _tmp0_;
	JsonParser* _tmp5_;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
#line 1897 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1897 "../core/Services/Database.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 1898 "../core/Services/Database.vala"
	_tmp0_ = self->priv->parser;
#line 1898 "../core/Services/Database.vala"
	if (_tmp0_ == NULL) {
#line 8169 "Database.c"
		JsonParser* _tmp1_;
#line 1899 "../core/Services/Database.vala"
		_tmp1_ = json_parser_new ();
#line 1899 "../core/Services/Database.vala"
		_g_object_unref0 (self->priv->parser);
#line 1899 "../core/Services/Database.vala"
		self->priv->parser = _tmp1_;
#line 8177 "Database.c"
	}
	{
		JsonParser* _tmp2_;
#line 1903 "../core/Services/Database.vala"
		_tmp2_ = self->priv->parser;
#line 1903 "../core/Services/Database.vala"
		json_parser_load_from_data (_tmp2_, data, (gssize) -1, &_inner_error0_);
#line 1903 "../core/Services/Database.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8187 "Database.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 1902 "../core/Services/Database.vala"
		e = _inner_error0_;
#line 1902 "../core/Services/Database.vala"
		_inner_error0_ = NULL;
#line 1905 "../core/Services/Database.vala"
		_tmp3_ = e;
#line 1905 "../core/Services/Database.vala"
		_tmp4_ = _tmp3_->message;
#line 1905 "../core/Services/Database.vala"
		g_debug ("Database.vala:1905: %s", _tmp4_);
#line 1902 "../core/Services/Database.vala"
		_g_error_free0 (e);
#line 8209 "Database.c"
	}
	__finally0:
#line 1902 "../core/Services/Database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1902 "../core/Services/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1902 "../core/Services/Database.vala"
		g_clear_error (&_inner_error0_);
#line 1902 "../core/Services/Database.vala"
		return NULL;
#line 8220 "Database.c"
	}
#line 1908 "../core/Services/Database.vala"
	_tmp5_ = self->priv->parser;
#line 1908 "../core/Services/Database.vala"
	_tmp6_ = json_parser_get_root (_tmp5_);
#line 1908 "../core/Services/Database.vala"
	_tmp7_ = json_node_get_object (_tmp6_);
#line 1908 "../core/Services/Database.vala"
	_tmp8_ = _json_object_ref0 (_tmp7_);
#line 1908 "../core/Services/Database.vala"
	result = _tmp8_;
#line 1908 "../core/Services/Database.vala"
	return result;
#line 8234 "Database.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 8257 "Database.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 8266 "Database.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 8285 "Database.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 8289 "Database.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 8295 "Database.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 8305 "Database.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 8313 "Database.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 8317 "Database.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 8323 "Database.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 8333 "Database.c"
}

gchar*
services_database_get_labels_ids (ServicesDatabase* self,
                                  GeeArrayList* labels)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* result;
#line 1911 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1911 "../core/Services/Database.vala"
	g_return_val_if_fail (labels != NULL, NULL);
#line 1912 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("");
#line 1912 "../core/Services/Database.vala"
	return_value = _tmp0_;
#line 8354 "Database.c"
	{
		GeeArrayList* _label_list = NULL;
		gint _label_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _label_index = 0;
#line 1914 "../core/Services/Database.vala"
		_label_list = labels;
#line 1914 "../core/Services/Database.vala"
		_tmp1_ = _label_list;
#line 1914 "../core/Services/Database.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1914 "../core/Services/Database.vala"
		_tmp3_ = _tmp2_;
#line 1914 "../core/Services/Database.vala"
		_label_size = _tmp3_;
#line 1914 "../core/Services/Database.vala"
		_label_index = -1;
#line 1914 "../core/Services/Database.vala"
		while (TRUE) {
#line 8376 "Database.c"
			gint _tmp4_;
			gint _tmp5_;
			ObjectsLabel* label = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			ObjectsLabel* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 1914 "../core/Services/Database.vala"
			_label_index = _label_index + 1;
#line 1914 "../core/Services/Database.vala"
			_tmp4_ = _label_index;
#line 1914 "../core/Services/Database.vala"
			_tmp5_ = _label_size;
#line 1914 "../core/Services/Database.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1914 "../core/Services/Database.vala"
				break;
#line 8399 "Database.c"
			}
#line 1914 "../core/Services/Database.vala"
			_tmp6_ = _label_list;
#line 1914 "../core/Services/Database.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _label_index);
#line 1914 "../core/Services/Database.vala"
			label = (ObjectsLabel*) _tmp7_;
#line 1915 "../core/Services/Database.vala"
			_tmp8_ = return_value;
#line 1915 "../core/Services/Database.vala"
			_tmp9_ = label;
#line 1915 "../core/Services/Database.vala"
			_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp9_);
#line 1915 "../core/Services/Database.vala"
			_tmp11_ = _tmp10_;
#line 1915 "../core/Services/Database.vala"
			_tmp12_ = g_strconcat (_tmp11_, ";", NULL);
#line 1915 "../core/Services/Database.vala"
			_tmp13_ = _tmp12_;
#line 1915 "../core/Services/Database.vala"
			_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
#line 1915 "../core/Services/Database.vala"
			_g_free0 (return_value);
#line 1915 "../core/Services/Database.vala"
			return_value = _tmp14_;
#line 1915 "../core/Services/Database.vala"
			_g_free0 (_tmp13_);
#line 1914 "../core/Services/Database.vala"
			_g_object_unref0 (label);
#line 8429 "Database.c"
		}
	}
#line 1918 "../core/Services/Database.vala"
	_tmp15_ = return_value;
#line 1918 "../core/Services/Database.vala"
	_tmp16_ = strlen (_tmp15_);
#line 1918 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 1918 "../core/Services/Database.vala"
	if (_tmp17_ > 0) {
#line 8440 "Database.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gchar* _tmp22_;
#line 1919 "../core/Services/Database.vala"
		_tmp18_ = return_value;
#line 1919 "../core/Services/Database.vala"
		_tmp19_ = return_value;
#line 1919 "../core/Services/Database.vala"
		_tmp20_ = strlen (_tmp19_);
#line 1919 "../core/Services/Database.vala"
		_tmp21_ = _tmp20_;
#line 1919 "../core/Services/Database.vala"
		_tmp22_ = string_substring (_tmp18_, (glong) 0, (glong) (_tmp21_ - 1));
#line 1919 "../core/Services/Database.vala"
		_g_free0 (return_value);
#line 1919 "../core/Services/Database.vala"
		return_value = _tmp22_;
#line 8460 "Database.c"
	}
#line 1922 "../core/Services/Database.vala"
	result = return_value;
#line 1922 "../core/Services/Database.vala"
	return result;
#line 8466 "Database.c"
}

gboolean
services_database_column_exists (ServicesDatabase* self,
                                 const gchar* table,
                                 const gchar* column)
{
	sqlite3_stmt* stmt = NULL;
	gboolean returned = FALSE;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	gboolean result;
#line 1925 "../core/Services/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1925 "../core/Services/Database.vala"
	g_return_val_if_fail (table != NULL, FALSE);
#line 1925 "../core/Services/Database.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 1927 "../core/Services/Database.vala"
	returned = FALSE;
#line 1929 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n            PRAGMA table_info(%s);\n        ", table);
#line 1929 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1929 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1933 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1933 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1933 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1933 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1933 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1933 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1933 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1933 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1935 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1935 "../core/Services/Database.vala"
	sqlite3_step (_tmp7_);
#line 1937 "../core/Services/Database.vala"
	while (TRUE) {
#line 8521 "Database.c"
		sqlite3_stmt* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
#line 1937 "../core/Services/Database.vala"
		_tmp8_ = stmt;
#line 1937 "../core/Services/Database.vala"
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
#line 1937 "../core/Services/Database.vala"
			break;
#line 8531 "Database.c"
		}
#line 1938 "../core/Services/Database.vala"
		_tmp9_ = stmt;
#line 1938 "../core/Services/Database.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 1);
#line 1938 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp10_, column) == 0) {
#line 1939 "../core/Services/Database.vala"
			returned = TRUE;
#line 8541 "Database.c"
		}
	}
#line 1944 "../core/Services/Database.vala"
	result = returned;
#line 1944 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1944 "../core/Services/Database.vala"
	return result;
#line 8550 "Database.c"
}

void
services_database_add_text_column (ServicesDatabase* self,
                                   const gchar* table,
                                   const gchar* column,
                                   const gchar* default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 1947 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1947 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 1947 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 1947 "../core/Services/Database.vala"
	g_return_if_fail (default_value != NULL);
#line 1948 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 1949 "../core/Services/Database.vala"
		return;
#line 8580 "Database.c"
	}
#line 1954 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s TEXT DEFAULT '%s';\n" \
"        ", table, column, default_value);
#line 1954 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1954 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1958 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1958 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1958 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1958 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1958 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1958 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1958 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1958 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1960 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1960 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 8608 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 1961 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 1961 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1961 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 1961 "../core/Services/Database.vala"
		g_warning ("Database.vala:1961: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 8620 "Database.c"
	}
#line 1947 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8624 "Database.c"
}

void
services_database_add_int_column (ServicesDatabase* self,
                                  const gchar* table,
                                  const gchar* column,
                                  gint default_value)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 1967 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1967 "../core/Services/Database.vala"
	g_return_if_fail (table != NULL);
#line 1967 "../core/Services/Database.vala"
	g_return_if_fail (column != NULL);
#line 1968 "../core/Services/Database.vala"
	if (services_database_column_exists (self, table, column)) {
#line 1969 "../core/Services/Database.vala"
		return;
#line 8652 "Database.c"
	}
#line 1974 "../core/Services/Database.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            ALTER TABLE %s ADD COLUMN %s INTEGER DEFAULT %i;\n" \
"        ", table, column, default_value);
#line 1974 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1974 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 1978 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 1978 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 1978 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 1978 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 1978 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 1978 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 1978 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 1978 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 1980 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 1980 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 8680 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 1981 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 1981 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 1981 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 1981 "../core/Services/Database.vala"
		g_warning ("Database.vala:1981: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 8692 "Database.c"
	}
#line 1967 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8696 "Database.c"
}

void
services_database_add_item_label_column (ServicesDatabase* self)
{
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
#line 1987 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 1988 "../core/Services/Database.vala"
	if (services_database_column_exists (self, "Items", "labels")) {
#line 1989 "../core/Services/Database.vala"
		return;
#line 8717 "Database.c"
	}
#line 1994 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            ALTER TABLE Items ADD COLUMN labels TEXT;\n" \
"\n" \
"            UPDATE Items\n" \
"            SET labels = (\n" \
"                SELECT GROUP_CONCAT(label_id, ';')\n" \
"                FROM Items_Labels\n" \
"                WHERE item_id = Items.id\n" \
"            );\n" \
"        ");
#line 1994 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1994 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2005 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2005 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2005 "../core/Services/Database.vala"
	_tmp3_ = self->priv->sql;
#line 2005 "../core/Services/Database.vala"
	_tmp4_ = strlen (_tmp3_);
#line 2005 "../core/Services/Database.vala"
	_tmp5_ = _tmp4_;
#line 2005 "../core/Services/Database.vala"
	sqlite3_prepare_v2 (_tmp1_, _tmp2_, _tmp5_, &_tmp6_, NULL);
#line 2005 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 2005 "../core/Services/Database.vala"
	stmt = _tmp6_;
#line 2007 "../core/Services/Database.vala"
	_tmp7_ = stmt;
#line 2007 "../core/Services/Database.vala"
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
#line 8745 "Database.c"
		sqlite3* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 2008 "../core/Services/Database.vala"
		_tmp8_ = self->priv->db;
#line 2008 "../core/Services/Database.vala"
		_tmp9_ = self->priv->db;
#line 2008 "../core/Services/Database.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 2008 "../core/Services/Database.vala"
		g_warning ("Database.vala:2008: Error: %d: %s", sqlite3_errcode (_tmp8_), _tmp10_);
#line 8757 "Database.c"
	}
#line 1987 "../core/Services/Database.vala"
	_sqlite3_finalize0 (stmt);
#line 8761 "Database.c"
}

void
services_database_add_project_labels_source_id (ServicesDatabase* self)
{
	gchar* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* _tmp6_;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gint _tmp10_;
	Util* _tmp12_;
	Util* _tmp13_;
	ObjectsSource* _tmp14_;
	ObjectsSource* _tmp15_;
	ServicesTodoist* _tmp16_;
	ServicesTodoist* _tmp17_;
	gboolean _tmp18_;
	ServicesCalDAVCore* _tmp45_;
	ServicesCalDAVCore* _tmp46_;
	gboolean _tmp47_;
#line 2014 "../core/Services/Database.vala"
	g_return_if_fail (self != NULL);
#line 2015 "../core/Services/Database.vala"
	if (services_database_column_exists (self, "Projects", "source_id")) {
#line 2016 "../core/Services/Database.vala"
		return;
#line 8793 "Database.c"
	}
#line 2019 "../core/Services/Database.vala"
	_tmp0_ = g_strdup ("\n" \
"            ALTER TABLE Projects ADD COLUMN source_id TEXT;\n" \
"            UPDATE Projects SET source_id = backend_type;\n" \
"        ");
#line 2019 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2019 "../core/Services/Database.vala"
	self->priv->sql = _tmp0_;
#line 2024 "../core/Services/Database.vala"
	_tmp1_ = self->priv->db;
#line 2024 "../core/Services/Database.vala"
	_tmp2_ = self->priv->sql;
#line 2024 "../core/Services/Database.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 2024 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 2024 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp3_;
#line 2024 "../core/Services/Database.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 8813 "Database.c"
		const gchar* _tmp5_;
#line 2025 "../core/Services/Database.vala"
		_tmp5_ = self->priv->errormsg;
#line 2025 "../core/Services/Database.vala"
		g_warning ("Database.vala:2025: %s", _tmp5_);
#line 8819 "Database.c"
	}
#line 2028 "../core/Services/Database.vala"
	_tmp6_ = g_strdup ("\n" \
"            ALTER TABLE Labels ADD COLUMN source_id TEXT;\n" \
"            UPDATE Labels SET source_id = backend_type;\n" \
"        ");
#line 2028 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 2028 "../core/Services/Database.vala"
	self->priv->sql = _tmp6_;
#line 2033 "../core/Services/Database.vala"
	_tmp7_ = self->priv->db;
#line 2033 "../core/Services/Database.vala"
	_tmp8_ = self->priv->sql;
#line 2033 "../core/Services/Database.vala"
	_tmp10_ = _sqlite3_exec (_tmp7_, _tmp8_, NULL, NULL, &_tmp9_);
#line 2033 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 2033 "../core/Services/Database.vala"
	self->priv->errormsg = _tmp9_;
#line 2033 "../core/Services/Database.vala"
	if (_tmp10_ != SQLITE_OK) {
#line 8839 "Database.c"
		const gchar* _tmp11_;
#line 2034 "../core/Services/Database.vala"
		_tmp11_ = self->priv->errormsg;
#line 2034 "../core/Services/Database.vala"
		g_warning ("Database.vala:2034: %s", _tmp11_);
#line 8845 "Database.c"
	}
#line 2037 "../core/Services/Database.vala"
	_tmp12_ = util_get_default ();
#line 2037 "../core/Services/Database.vala"
	_tmp13_ = _tmp12_;
#line 2037 "../core/Services/Database.vala"
	_tmp14_ = util_create_local_source (_tmp13_);
#line 2037 "../core/Services/Database.vala"
	_tmp15_ = _tmp14_;
#line 2037 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp15_);
#line 2037 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp13_);
#line 2039 "../core/Services/Database.vala"
	_tmp16_ = services_todoist_get_default ();
#line 2039 "../core/Services/Database.vala"
	_tmp17_ = _tmp16_;
#line 2039 "../core/Services/Database.vala"
	_tmp18_ = services_todoist_is_logged_in (_tmp17_);
#line 2039 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp17_);
#line 2039 "../core/Services/Database.vala"
	if (_tmp18_) {
#line 8869 "Database.c"
		ObjectsSource* todoist_source = NULL;
		ObjectsSource* _tmp19_;
		ObjectsSource* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		ObjectsSource* _tmp23_;
		ObjectsSource* _tmp24_;
		ServicesSettings* _tmp25_;
		ServicesSettings* _tmp26_;
		GSettings* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		ObjectsSource* _tmp30_;
		ObjectsSourceTodoistData* _tmp31_;
		ObjectsSourceTodoistData* _tmp32_;
		ObjectsSource* _tmp33_;
		ServicesSettings* _tmp34_;
		ServicesSettings* _tmp35_;
		GSettings* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		ObjectsSource* _tmp39_;
		ServicesSettings* _tmp40_;
		ServicesSettings* _tmp41_;
		GSettings* _tmp42_;
		ServicesStore* _tmp43_;
		ObjectsSource* _tmp44_;
#line 2040 "../core/Services/Database.vala"
		_tmp19_ = objects_source_new ();
#line 2040 "../core/Services/Database.vala"
		todoist_source = _tmp19_;
#line 2041 "../core/Services/Database.vala"
		_tmp20_ = todoist_source;
#line 2041 "../core/Services/Database.vala"
		_tmp21_ = source_type_to_string (SOURCE_TYPE_TODOIST);
#line 2041 "../core/Services/Database.vala"
		_tmp22_ = _tmp21_;
#line 2041 "../core/Services/Database.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp20_, _tmp22_);
#line 2041 "../core/Services/Database.vala"
		_g_free0 (_tmp22_);
#line 2042 "../core/Services/Database.vala"
		_tmp23_ = todoist_source;
#line 2042 "../core/Services/Database.vala"
		objects_source_set_source_type (_tmp23_, SOURCE_TYPE_TODOIST);
#line 2043 "../core/Services/Database.vala"
		_tmp24_ = todoist_source;
#line 2043 "../core/Services/Database.vala"
		_tmp25_ = services_settings_get_default ();
#line 2043 "../core/Services/Database.vala"
		_tmp26_ = _tmp25_;
#line 2043 "../core/Services/Database.vala"
		_tmp27_ = _tmp26_->settings;
#line 2043 "../core/Services/Database.vala"
		_tmp28_ = g_settings_get_string (_tmp27_, "todoist-user-email");
#line 2043 "../core/Services/Database.vala"
		_tmp29_ = _tmp28_;
#line 2043 "../core/Services/Database.vala"
		objects_source_set_display_name (_tmp24_, _tmp29_);
#line 2043 "../core/Services/Database.vala"
		_g_free0 (_tmp29_);
#line 2043 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp26_);
#line 2044 "../core/Services/Database.vala"
		_tmp30_ = todoist_source;
#line 2044 "../core/Services/Database.vala"
		_tmp31_ = utils_account_migrate_get_data_from_todoist ();
#line 2044 "../core/Services/Database.vala"
		_tmp32_ = _tmp31_;
#line 2044 "../core/Services/Database.vala"
		objects_source_set_data (_tmp30_, (ObjectsSourceData*) _tmp32_);
#line 2044 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp32_);
#line 2045 "../core/Services/Database.vala"
		_tmp33_ = todoist_source;
#line 2045 "../core/Services/Database.vala"
		_tmp34_ = services_settings_get_default ();
#line 2045 "../core/Services/Database.vala"
		_tmp35_ = _tmp34_;
#line 2045 "../core/Services/Database.vala"
		_tmp36_ = _tmp35_->settings;
#line 2045 "../core/Services/Database.vala"
		_tmp37_ = g_settings_get_string (_tmp36_, "todoist-last-sync");
#line 2045 "../core/Services/Database.vala"
		_tmp38_ = _tmp37_;
#line 2045 "../core/Services/Database.vala"
		objects_source_set_last_sync (_tmp33_, _tmp38_);
#line 2045 "../core/Services/Database.vala"
		_g_free0 (_tmp38_);
#line 2045 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp35_);
#line 2046 "../core/Services/Database.vala"
		_tmp39_ = todoist_source;
#line 2046 "../core/Services/Database.vala"
		_tmp40_ = services_settings_get_default ();
#line 2046 "../core/Services/Database.vala"
		_tmp41_ = _tmp40_;
#line 2046 "../core/Services/Database.vala"
		_tmp42_ = _tmp41_->settings;
#line 2046 "../core/Services/Database.vala"
		objects_source_set_sync_server (_tmp39_, g_settings_get_boolean (_tmp42_, "todoist-sync-server"));
#line 2046 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp41_);
#line 2048 "../core/Services/Database.vala"
		_tmp43_ = services_store_instance ();
#line 2048 "../core/Services/Database.vala"
		_tmp44_ = todoist_source;
#line 2048 "../core/Services/Database.vala"
		services_store_insert_source (_tmp43_, _tmp44_);
#line 2039 "../core/Services/Database.vala"
		_g_object_unref0 (todoist_source);
#line 8981 "Database.c"
	}
#line 2051 "../core/Services/Database.vala"
	_tmp45_ = services_cal_dav_core_get_default ();
#line 2051 "../core/Services/Database.vala"
	_tmp46_ = _tmp45_;
#line 2051 "../core/Services/Database.vala"
	_tmp47_ = services_cal_dav_core_is_logged_in (_tmp46_);
#line 2051 "../core/Services/Database.vala"
	_g_object_unref0 (_tmp46_);
#line 2051 "../core/Services/Database.vala"
	if (_tmp47_) {
#line 8993 "Database.c"
		ObjectsSource* caldav_source = NULL;
		ObjectsSource* _tmp48_;
		ObjectsSource* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		ObjectsSource* _tmp52_;
		ObjectsSource* _tmp53_;
		ObjectsSourceCalDAVData* _tmp54_;
		ObjectsSourceCalDAVData* _tmp55_;
		ObjectsSource* _tmp56_;
		ServicesSettings* _tmp57_;
		ServicesSettings* _tmp58_;
		GSettings* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		ObjectsSource* _tmp62_;
		ServicesSettings* _tmp63_;
		ServicesSettings* _tmp64_;
		GSettings* _tmp65_;
		ObjectsSource* _tmp66_;
		ObjectsSourceCalDAVData* _tmp67_;
		ObjectsSourceCalDAVData* _tmp68_;
		const gchar* _tmp69_;
		const gchar* _tmp70_;
		ServicesStore* _tmp89_;
		ObjectsSource* _tmp90_;
#line 2052 "../core/Services/Database.vala"
		_tmp48_ = objects_source_new ();
#line 2052 "../core/Services/Database.vala"
		caldav_source = _tmp48_;
#line 2053 "../core/Services/Database.vala"
		_tmp49_ = caldav_source;
#line 2053 "../core/Services/Database.vala"
		_tmp50_ = source_type_to_string (SOURCE_TYPE_CALDAV);
#line 2053 "../core/Services/Database.vala"
		_tmp51_ = _tmp50_;
#line 2053 "../core/Services/Database.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp49_, _tmp51_);
#line 2053 "../core/Services/Database.vala"
		_g_free0 (_tmp51_);
#line 2054 "../core/Services/Database.vala"
		_tmp52_ = caldav_source;
#line 2054 "../core/Services/Database.vala"
		objects_source_set_source_type (_tmp52_, SOURCE_TYPE_CALDAV);
#line 2055 "../core/Services/Database.vala"
		_tmp53_ = caldav_source;
#line 2055 "../core/Services/Database.vala"
		_tmp54_ = utils_account_migrate_get_data_from_caldav ();
#line 2055 "../core/Services/Database.vala"
		_tmp55_ = _tmp54_;
#line 2055 "../core/Services/Database.vala"
		objects_source_set_data (_tmp53_, (ObjectsSourceData*) _tmp55_);
#line 2055 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp55_);
#line 2056 "../core/Services/Database.vala"
		_tmp56_ = caldav_source;
#line 2056 "../core/Services/Database.vala"
		_tmp57_ = services_settings_get_default ();
#line 2056 "../core/Services/Database.vala"
		_tmp58_ = _tmp57_;
#line 2056 "../core/Services/Database.vala"
		_tmp59_ = _tmp58_->settings;
#line 2056 "../core/Services/Database.vala"
		_tmp60_ = g_settings_get_string (_tmp59_, "caldav-last-sync");
#line 2056 "../core/Services/Database.vala"
		_tmp61_ = _tmp60_;
#line 2056 "../core/Services/Database.vala"
		objects_source_set_last_sync (_tmp56_, _tmp61_);
#line 2056 "../core/Services/Database.vala"
		_g_free0 (_tmp61_);
#line 2056 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp58_);
#line 2057 "../core/Services/Database.vala"
		_tmp62_ = caldav_source;
#line 2057 "../core/Services/Database.vala"
		_tmp63_ = services_settings_get_default ();
#line 2057 "../core/Services/Database.vala"
		_tmp64_ = _tmp63_;
#line 2057 "../core/Services/Database.vala"
		_tmp65_ = _tmp64_->settings;
#line 2057 "../core/Services/Database.vala"
		objects_source_set_sync_server (_tmp62_, g_settings_get_boolean (_tmp65_, "caldav-sync-server"));
#line 2057 "../core/Services/Database.vala"
		_g_object_unref0 (_tmp64_);
#line 2059 "../core/Services/Database.vala"
		_tmp66_ = caldav_source;
#line 2059 "../core/Services/Database.vala"
		_tmp67_ = objects_source_get_caldav_data (_tmp66_);
#line 2059 "../core/Services/Database.vala"
		_tmp68_ = _tmp67_;
#line 2059 "../core/Services/Database.vala"
		_tmp69_ = objects_source_cal_dav_data_get_user_email (_tmp68_);
#line 2059 "../core/Services/Database.vala"
		_tmp70_ = _tmp69_;
#line 2059 "../core/Services/Database.vala"
		if (g_strcmp0 (_tmp70_, "") != 0) {
#line 9090 "Database.c"
			ObjectsSource* _tmp71_;
			ObjectsSource* _tmp72_;
			ObjectsSourceCalDAVData* _tmp73_;
			ObjectsSourceCalDAVData* _tmp74_;
			const gchar* _tmp75_;
			const gchar* _tmp76_;
#line 2060 "../core/Services/Database.vala"
			_tmp71_ = caldav_source;
#line 2060 "../core/Services/Database.vala"
			_tmp72_ = caldav_source;
#line 2060 "../core/Services/Database.vala"
			_tmp73_ = objects_source_get_caldav_data (_tmp72_);
#line 2060 "../core/Services/Database.vala"
			_tmp74_ = _tmp73_;
#line 2060 "../core/Services/Database.vala"
			_tmp75_ = objects_source_cal_dav_data_get_user_email (_tmp74_);
#line 2060 "../core/Services/Database.vala"
			_tmp76_ = _tmp75_;
#line 2060 "../core/Services/Database.vala"
			objects_source_set_display_name (_tmp71_, _tmp76_);
#line 9111 "Database.c"
		} else {
			ObjectsSource* _tmp77_;
			ObjectsSourceCalDAVData* _tmp78_;
			ObjectsSourceCalDAVData* _tmp79_;
			const gchar* _tmp80_;
			const gchar* _tmp81_;
#line 2061 "../core/Services/Database.vala"
			_tmp77_ = caldav_source;
#line 2061 "../core/Services/Database.vala"
			_tmp78_ = objects_source_get_caldav_data (_tmp77_);
#line 2061 "../core/Services/Database.vala"
			_tmp79_ = _tmp78_;
#line 2061 "../core/Services/Database.vala"
			_tmp80_ = objects_source_cal_dav_data_get_user_displayname (_tmp79_);
#line 2061 "../core/Services/Database.vala"
			_tmp81_ = _tmp80_;
#line 2061 "../core/Services/Database.vala"
			if (g_strcmp0 (_tmp81_, "") != 0) {
#line 9130 "Database.c"
				ObjectsSource* _tmp82_;
				ObjectsSource* _tmp83_;
				ObjectsSourceCalDAVData* _tmp84_;
				ObjectsSourceCalDAVData* _tmp85_;
				const gchar* _tmp86_;
				const gchar* _tmp87_;
#line 2062 "../core/Services/Database.vala"
				_tmp82_ = caldav_source;
#line 2062 "../core/Services/Database.vala"
				_tmp83_ = caldav_source;
#line 2062 "../core/Services/Database.vala"
				_tmp84_ = objects_source_get_caldav_data (_tmp83_);
#line 2062 "../core/Services/Database.vala"
				_tmp85_ = _tmp84_;
#line 2062 "../core/Services/Database.vala"
				_tmp86_ = objects_source_cal_dav_data_get_user_displayname (_tmp85_);
#line 2062 "../core/Services/Database.vala"
				_tmp87_ = _tmp86_;
#line 2062 "../core/Services/Database.vala"
				objects_source_set_display_name (_tmp82_, _tmp87_);
#line 9151 "Database.c"
			} else {
				ObjectsSource* _tmp88_;
#line 2064 "../core/Services/Database.vala"
				_tmp88_ = caldav_source;
#line 2064 "../core/Services/Database.vala"
				objects_source_set_display_name (_tmp88_, _ ("Nextcloud"));
#line 9158 "Database.c"
			}
		}
#line 2067 "../core/Services/Database.vala"
		_tmp89_ = services_store_instance ();
#line 2067 "../core/Services/Database.vala"
		_tmp90_ = caldav_source;
#line 2067 "../core/Services/Database.vala"
		services_store_insert_source (_tmp89_, _tmp90_);
#line 2051 "../core/Services/Database.vala"
		_g_object_unref0 (caldav_source);
#line 9169 "Database.c"
	}
}

ServicesDatabase*
services_database_construct (GType object_type)
{
	ServicesDatabase * self = NULL;
#line 22 "../core/Services/Database.vala"
	self = (ServicesDatabase*) g_object_new (object_type, NULL);
#line 22 "../core/Services/Database.vala"
	return self;
#line 9181 "Database.c"
}

ServicesDatabase*
services_database_new (void)
{
#line 22 "../core/Services/Database.vala"
	return services_database_construct (SERVICES_TYPE_DATABASE);
#line 9189 "Database.c"
}

static void
services_database_class_init (ServicesDatabaseClass * klass,
                              gpointer klass_data)
{
#line 22 "../core/Services/Database.vala"
	services_database_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/Database.vala"
	g_type_class_adjust_private_offset (klass, &ServicesDatabase_private_offset);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (klass)->finalize = services_database_finalize;
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_OPENED_SIGNAL] = g_signal_new ("opened", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Services/Database.vala"
	services_database_signals[SERVICES_DATABASE_RESET_SIGNAL] = g_signal_new ("reset", SERVICES_TYPE_DATABASE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9206 "Database.c"
}

static void
services_database_instance_init (ServicesDatabase * self,
                                 gpointer klass)
{
#line 22 "../core/Services/Database.vala"
	self->priv = services_database_get_instance_private (self);
#line 9215 "Database.c"
}

static void
services_database_finalize (GObject * obj)
{
	ServicesDatabase * self;
#line 22 "../core/Services/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_DATABASE, ServicesDatabase);
#line 23 "../core/Services/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 24 "../core/Services/Database.vala"
	_g_free0 (self->priv->db_path);
#line 25 "../core/Services/Database.vala"
	_g_free0 (self->priv->errormsg);
#line 26 "../core/Services/Database.vala"
	_g_free0 (self->priv->sql);
#line 1896 "../core/Services/Database.vala"
	_g_object_unref0 (self->priv->parser);
#line 22 "../core/Services/Database.vala"
	G_OBJECT_CLASS (services_database_parent_class)->finalize (obj);
#line 9236 "Database.c"
}

static GType
services_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesDatabase), 0, (GInstanceInitFunc) services_database_instance_init, NULL };
	GType services_database_type_id;
	services_database_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesDatabase", &g_define_type_info, 0);
	ServicesDatabase_private_offset = g_type_add_instance_private (services_database_type_id, sizeof (ServicesDatabasePrivate));
	return services_database_type_id;
}

GType
services_database_get_type (void)
{
	static volatile gsize services_database_type_id__once = 0;
	if (g_once_init_enter (&services_database_type_id__once)) {
		GType services_database_type_id;
		services_database_type_id = services_database_get_type_once ();
		g_once_init_leave (&services_database_type_id__once, services_database_type_id);
	}
	return services_database_type_id__once;
}

